<?

// (1.A) some generally valid system constants

$gSmeFontSize=10;
$gMmeFontSize=11;
$gDefFontSize=12;

$gActuallyValidCfgFileNameFile="actually-valid-cfg-file.txt";
$gBuildDirectory="build";

// (1.B) some derivated globale constants
$gRelativeBuildPath="../$gBuildDirectory";
$gRelativePathToValidCfgFileNameFile="$gRelativeBuildPath/$gActuallyValidCfgFileNameFile";


// (2) list the names of all lgsp-cfg-file of the build-driectory
function formCfgFileList()
{
  global $gRelativeBuildPath;
  
  $fileArray=array();
  $dd=opendir($gRelativeBuildPath);
  while($fn=readdir($dd))
  {
    if ((!(ereg("bak",$fn))) && (ereg("\.cfg\.inc",$fn)))
      array_push($fileArray,$fn);
  }
  closedir($dd);
  sort($fileArray);
  return $fileArray;
}


// (3.a) change and store the name of the actually valid lgsp-cfg-file
function updateActuallyValidCfgFileName($pLgspCfgFileName)
{
  global $gRelativePathToValidCfgFileNameFile;
  $fd=fopen($gRelativePathToValidCfgFileNameFile,"w");
  if ($fd)
  {
    fwrite($fd,"$pLgspCfgFileName\n");
    fclose($fd);
  }
}
// (3.b) get the name of the actually valid lgsp-cfg-file
function getActuallyValidCfgFileName()
{
  global $gRelativePathToValidCfgFileNameFile;
  if (!(file_exists($gRelativePathToValidCfgFileNameFile)))
    return "";
  $lgspCfgFileName="unknown";
  $fd=fopen($gRelativePathToValidCfgFileNameFile,"r");
  if ($fd)
  {
    $lgspCfgFileName=fread($fd,1024);
    fclose($fd);
  }
  return trim($lgspCfgFileName);
}


// (4.A) return the content of th actually valid cfg file as array
function getActualValidCfgArray()
{
  global $gRelativeBuildPath;
  $actualCfgFileName=getActuallyValidCfgFileName();
  if (!($actualCfgFileName))
    return array();
  $actualCfgFile=($gRelativeBuildPath ."/" . $actualCfgFileName);
  if (file_exists($actualCfgFile))
    return include ($actualCfgFile);
  else
    return array();
}

// (4.B) return the content of th actually valid cfg file as array
function getSpecificCfgArray($pCfgFileName)
{
  global $gRelativeBuildPath;
  $cfgFilePath=($gRelativeBuildPath ."/" . $pCfgFileName);
  if (file_exists($cfgFilePath))
    return include ($cfgFilePath);
  else
    return array();
}



// (5.A) form table line with a site default configuration value
function formDefEntry($pDefBgColor,$pAttribute,$pValue,$pComment)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"5\" align=\"right\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"\n");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("\"" . htmlentities($pValue)."\",\n");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" align=\"left\">\n";
  $ln.="    <font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */\n" );
  $ln.="      </span>\n";
  $ln.="    </font>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  return $ln;
}

// (5.B.a) form the start line of the main-menu-entries
function formMmeArrayStart($pDefBgColor,$pMmeBgColor,$pAttribute,$pComment)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"5\" align=\"right\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.="array\n";
   $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */" );
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  
   return $ln;
}
// (5.B.b) form the key line of the main-menu-entries
function formMmeKeyEntry($pDefBgColor,$pMmeBgColor,$pKey,$withOpBracket=false)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  if ($withOpBracket)
    $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">(</td>\n";
  else
    $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"4\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=htmlentities($pKey);
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.="array\n";
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">&nbsp;\n";
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
   return $ln;
}

// (5.B.c) form the closing key line of the main-menu-entries
function formMmeKeyClosure($pDefBgColor,$pMmeBgColor)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">)</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"7\">&nbsp;</td>\n";
  $ln.="</tr>\n";
   return $ln;
}

// (5.B.d) form one configuration-value-line of the main-menu-entry
function formMmeEntry($pDefBgColor,$pMmeBgColor,$pAttribute,$pValue,$pComment,$withOpBracket=false)
{
  global $gMmeFontSize;

  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  if ($withOpBracket)
    $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">(</td>\n";
  else
    $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"3\" align=\"right\">\n";
  
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gMmeFontSize;\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gMmeFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gMmeFontSize;\">\n";
  $ln.=("\"" . htmlentities($pValue). "\",");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gMmeFontSize;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */" );
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  return $ln;
}
// (5.B.e) form the closing line of the one main-menu-entry
function formMmeClosure($pDefBgColor,$pMmeBgColor)
{
  global $gMmeFontSize;

  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"1\">),</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"7\">&nbsp;</td>\n";
  $ln.="</tr>\n";
  
  return $ln;
}

// (5.C.a) form the start line of the sub-menu-entries
function formSmeArrayStart($pDefBgColor,$pMmeBgColor,$pSmeBgColor,$pAttribute,$pComment)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"2\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"3\" align=\"right\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.="array\n";
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */" );
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  
   return $ln;
}

// (5.C.b) form the key line of the sub-menu-entries
function formSmeKeyEntry($pDefBgColor,$pMmeBgColor,$pSmeBgColor,$pKey,$withOpBracket=false)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"2\" align=\"left\">&nbsp;</td>\n";
  if ($withOpBracket)
    $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">(</td>\n";
  else
    $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.=htmlentities($pKey);
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">&nbsp;</td>\n";  
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gDefFontSize;\">\n";
  $ln.="array\n";
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gDefFontSize;\">&nbsp;\n";
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
   return $ln;
}
// (5.C.c) form the closing key line of the sub-menu-entries
function formSmeKeyClosure($pDefBgColor,$pMmeBgColor,$pSmeBgColor)
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"2\" align=\"left\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">),</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"5\">&nbsp;</td>\n";
  $ln.="</tr>\n";
  return $ln;
}

// (5.C.d) form one configuration-value-line of the sub-menu-entry
function formSmeEntry($pDefBgColor,$pMmeBgColor,$pSmeBgColor,$pAttribute,$pValue,$pComment,$withOpBracket=false)
{
  global $gSmeFontSize;
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"2\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  if ($withOpBracket)
    $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">(</td>\n";
  else
    $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"right\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gSmeFontSize;\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:$gSmeFontSize;\">=></span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <b><font face=\"helvetica,arial\" >\n";
  $ln.="      <span style=\"font-size:$gSmeFontSize;\">\n";
  $ln.=("\"" . htmlentities($pValue) . "\",");
  $ln.="      </span>\n";
  $ln.="    </font></b>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"left\">\n";
  $ln.="    <span style=\"font-size:$gSmeFontSize;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */" );
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  return $ln;
}

// (5.B.e) form the closing line of the one sub-menu-entry
function formSmeClosure($pDefBgColor,$pMmeBgColor,$pSmeBgColor)
{
  global $gSmeFontSize;
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pDefBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pMmeBgColor\" colspan=\"2\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">&nbsp;</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" colspan=\"1\">),</td>\n";
  $ln.="  <td bgcolor=\"$pSmeBgColor\" align=\"right\" colspan=\"4\">&nbsp;</td>\n";
  $ln.="</tr>\n";
  return $ln;
}


// (5.D) form grey delimiter
function formCfgDelimiter($pComment)
{
  $pFontSize="11"; 
  
  return
  (
    sprintf
    (
      ("<tr><td colspan=\"9\" align=\"right\" bgcolor=\"#bbbbbb\" \n>" .
      "  <span style=\"font-size:%d;\">\n /*** %s ***/\n</span>\n" .
      "</td></tr>\n"),
      $pFontSize,
      htmlentities($pComment)
    )
  );
}

// (5.E) converted the content of the actually valid cfg file as html-string
function formHtmlTableOfLgspCfgFileContent($pLgspCfgArray)
{
  $dvec="#bbbbff";
  $mmec1="#ccffcc";
  $mmec2="#99ff99";
  $smec1="#ffcccc";
  $smec2="#ff9999";

  global $defFeatures;  
  global $mmeFeatures;  
  global $smeFeatures;  
  
  $cfgCont="<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";

  foreach ($defFeatures as $defDeterminer)
  {
    $defKey=$defDeterminer["key"];
    $defExplanation=$defDeterminer["exp"];
    if ($defKey=="DL")
    {
      $cfgCont.=formCfgDelimiter($defExplanation);
    }
    else
    {
      $defValue=$pLgspCfgArray[$defKey];
      if ($defValue)
      	$cfgCont.=formDefEntry($dvec,$defKey,$defValue,$defExplanation);
    }
  }
  
  $defOpen=true;
  $mmec=$mmec1;
  $smec=$smec1;
 
   
  if ((!($pLgspCfgArray["MAIN_MENU"]))||(sizeof($pLgspCfgArray["MAIN_MENU"])==0))
    $cfgCont.=formDefEntry($dvec,"MAIN_MENU","array()","all main-menu entries which group a sub-site");
  else
  {   
    ksort($pLgspCfgArray["MAIN_MENU"]);
    $cfgCont.=formMmeArrayStart($dvec,$mmec,"MAIN_MENU","all main-menu entries which group a sub-site");
    $mmeColorOne=true;
    foreach($pLgspCfgArray["MAIN_MENU"] as $mmeArrayKey => $mmeArray)
    {
      if ($mmeColorOne)
      {
        $mmec=$mmec1;
        $mmeColorOne=false;
      }
      else
      {
        $mmec=$mmec2;
        $mmeColorOne=true;
      }
      
      if ($mmeArray)
      {
      	$cfgCont.=formMmeKeyEntry($dvec,$mmec,$mmeArrayKey,$defOpen);
      	if ($defOpen)
	  $defOpen=false;
	   
	$mmeFirst=true;
      	foreach ($mmeFeatures as $mmeDeterminer)
      	{
      	  $mmeKey=$mmeDeterminer["key"];
      	  $mmeExplanation=$mmeDeterminer["exp"];
      	  if ($mmeKey=="DL")
      	  {
      	    $cfgCont.=formCfgDelimiter($mmeExplanation);
      	  }
	  else
	  {
      	    $mmeValue=$mmeArray[$mmeKey];
      	    if ($mmeValue)
      	      $cfgCont.=formMmeEntry($dvec,$mmec,$mmeKey,$mmeValue,$mmeExplanation,$mmeFirst);
      	    if ($mmeFirst)
	      $mmeFirst=false;
	  }
	  
      	}
      
        if ((!($mmeArray["SUB_MENU"]))||(sizeof($mmeArray["SUB_MENU"])==0))
          $cfgCont.=formMmeEntry($dvec,$mmec,"SUB_MENU","array()",
            "all sub-menu entries which are linked to real content pages",$mmeFirst);
        else
        {
      	  ksort($mmeArray["SUB_MENU"]);
      	  $cfgCont.=formSmeArrayStart
      	  ( $dvec,$mmec,$smec,"SUB_MENU",
	    "all sub-menu entries which are linked to real content pages");
	    	
     	  $mmeOpen=true;
	  $smeColorOne=true;
	  
          foreach($mmeArray["SUB_MENU"] as $smeArrayKey => $smeArray)
      	  {
	    
	    if ($smeColorOne)
	    {
	      $smec=$smec1;
	      $smeColorOne=false;
	    }
	    else
	    {
	      $smec=$smec2;
	      $smeColorOne=true;
	    }
	    if ($smeArray)
	    {
      	      $cfgCont.=formSmeKeyEntry($dvec,$mmec,$smec,$smeArrayKey,$mmeOpen);
      	      if ($mmeOpen)
	      	$mmeOpen=false;
		
 	      $smeFirst=true;
     	      foreach ($smeFeatures as $smeDeterminer)
      	      {
      	      	$smeKey=$smeDeterminer["key"];
      	      	$smeExplanation=$smeDeterminer["exp"];
      	      	$smeValue=$smeArray[$smeKey];
      	      	if ($smeValue)
      	      	  $cfgCont.=formSmeEntry($dvec,$mmec,$smec,$smeKey,$smeValue,$smeExplanation,$smeFirst);
      	      	if ($smeFirst)
	      	 $smeFirst=false;
	      }
	      $cfgCont.=formSmeClosure($dvec,$mmec,$smec);
      	    }
	  }
      	  $cfgCont.=formSmeKeyClosure($dvec,$mmec,$smec);
      	}
	$cfgCont.=formMmeClosure($dvec,$mmec);
	
      }
    }
  }
  
  $cfgCont.="</table>\n";
   
  return $cfgCont;
  
}

// (6.A) form a table line containing an input field
function formInputLineEntry($pAttribute,$pValue,$pComment,$pBgColor="#bbbbbb",$pVisSize="20",$pMaxSize="80")
{
  global $gDefFontSize;
  
  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"right\">\n";
  $ln.="    <span style=\"font-size:${gDefFontSize}pt;\">\n";
  $ln.="      <b><font face=\"helvetica,arial\">\n";
  $ln.=("\"" . htmlentities($pAttribute)."\"\n");
  $ln.="      </font></b>\n";
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:${gDefFontSize}pt;\">=>&nbsp;\"</span>\n";
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"center\">\n";
  $ln.=sprintf
  ( "    <input type=\"text\" name=\"VAR_$pAttribute\" value=\"%s\" size=\"$pVisSize\" maxsize=\"$pMaxSize\">\n",
    htmlentities($pValue)
  );
  $ln.="  </td>\n";
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"center\">\n";
  $ln.="    <span style=\"font-size:${gDefFontSize}pt;\">\",</span>\n";
  $ln.="  </td>\n";
  
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"right\">\n";
  $ln.="    <span style=\"font-size:${gDefFontSize}pt;\">\n";
  $ln.=("/* " . htmlentities($pComment) . " */\n" );
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  return $ln;
}
// (6.B) form a table line containing an input field
function formExplLineEntry($pExplanation,$pBgColor="#bbbbbb")
{
  global $gDefFontSize;

  $ln="<tr>\n";
  $ln.="  <td bgcolor=\"$pBgColor\" align=\"right\" colspan=\"5\">\n";
  $ln.="    <span style=\"font-size:${gDefFontSize}pt;\">\n";
  $ln.="      <b>\n";
  $ln.=("/* " . htmlentities($pExplanation)." */\n");
  $ln.="      </b>\n";
  $ln.="    </span>\n";
  $ln.="  </td>\n";
  $ln.="</tr>\n";
  return $ln;
}

// (6.B) form a table line containing a specific feature input field
function formFeatureInputFields($pCfgArray,$pCfgFeatures,$pBgColor)
{
  $trs="";
  foreach ($pCfgFeatures as $cfgDeterminer)
  {
    $key=$cfgDeterminer["key"];
    $explanation=$cfgDeterminer["exp"];
    if ($key=="DL")
    {
      $trs.=formExplLineEntry($explanation);
    }
    else
    {
      $value=$pCfgArray[$key];
      $inputType="";
      switch($key)
      {
        case "SITE_ID":	
	case "IMG_DIR":
	case "CSS_DIR":
	case "INTRO_MARKER":
	case "LOGO_MARKER":
	case "MENU_MARKER":
	case "GUIDE_MARKER":
      	  $visSize="16";
          $maxSize="40";
          break;
	case "WRITE_XML_DECLARATION":
	case "KEYWORDS_FREE_LANGUAGE":
	case "WITH_IMPRESSUM":
        case "WITH_LOGO_CORNER":
      	  $visSize="3";
          $maxSize="3";	  
	  break;
	case "ENCODING":
      	  $visSize="12";
          $maxSize="12";	  
	  break;
	case "ABSTRACT":
	case "DESCRIPTION":
      	  $visSize="30";
          $maxSize="120";	  
	  break;
	case "BACKGROUND_COLOR":
	case "LOGO_BACKGROUND_COLOR":
	case "MMAR_BACKGROUND_COLOR":
	case "SMAR_BACKGROUND_COLOR":
	case "PAGE_BACKGROUND_COLOR":
	case "TEXT_COLOR":
	case "LINK_COLOR":
	case "VLINK_COLOR":
	case "ALINK_COLOR":
	case "HOVER_COLOR":
	case "MME_BGSTRIPE_COLOR":
      	  $visSize="8";
          $maxSize="8";	  
	  break;
	case "MENU_AREA_HEIGHT":
	case "GUIDE_AREA_WIDTH":
	case "LOGO_TOP_MARGIN":
	case "MAIN_MENU_TOP_MARGIN":
	case "MME_BGSTRIPE_SIZE":
      	  $visSize="5";
          $maxSize="5";	  
	  break;
	  
      	default:
          $visSize="30";
          $maxSize="80";
          break;
      }
      $trs.=formInputLineEntry($key,$value,$explanation,$pBgColor,$visSize,$maxSize);
    }
  }
  return $trs;
}
// (7.A) form the rewritabale string of the given config array
function formCommentedCfgArrayRewriteString($pCfgArray)
{

  global $defFeatures;  
  global $mmeFeatures;  
  global $smeFeatures;  

  $rws="<?\n";
  $rws.="return array\n";
  $rws.="(\n";
  

  foreach ($defFeatures as $defDeterminer)
  {
    $levelOneKey=$defDeterminer["key"];
    $levelOneExplanation=$defDeterminer["exp"];
    if ($levelOneKey=="DL")
    {
      $rws.="  // ### $levelOneExplanation\n";
    }
    else
    {
      $levelOneValue=$pCfgArray[$levelOneKey];
            
      $rws.="  \"$levelOneKey\" => \"$levelOneValue\", // $levelOneExplanation\n";

    }
  }
  
  $rws.="  \"MAIN_MENU\" => array\n";
  $rws.="  (\n";
  
  foreach($pCfgArray["MAIN_MENU"] as $levelTwoKey => $levelThreeArray)
  {
    $rws.="    $levelTwoKey => array\n";
    $rws.="    (\n";
   
    foreach ($mmeFeatures as $mmeDeterminer)
    {
      $levelThreeKey=$mmeDeterminer["key"];
      $levelThreeExplanation=$mmeDeterminer["exp"];
      if ($levelThreeKey=="DL")
      {
      	$rws.="      // ### $levelThreeExplanation\n";
      }
      else
      {
      	$levelThreeValue=$levelThreeArray[$levelThreeKey];
      	$rws.="      \"$levelThreeKey\" => \"$levelThreeValue\", // $levelThreeExplanation\n";
      }
    }
    
    $rws.="      \"SUB_MENU\" => array\n";
    $rws.="      (\n";
    foreach($levelThreeArray["SUB_MENU"] as $levelFourKey => $levelFiveArray)
    {
      $rws.="        $levelFourKey => array\n";
      $rws.="        (\n";
      foreach ($smeFeatures as $smeDeterminer)
      {
      	$levelFiveKey=$smeDeterminer["key"];
      	$levelFiveExplanation=$smeDeterminer["exp"];
      	if ($levelFiveKey=="DL")
      	{
      	  $rws.="         // ### $levelFiveExplanation \n";
      	}
      	else
      	{
      	  $levelFiveValue=$levelFiveArray[$levelFiveKey];
	  $rws.="          \"$levelFiveKey\" => \"$levelFiveValue\", // $levelFiveExplanation\n";
	}
      }
       
      $rws.="        ),\n";    
    }    
    $rws.="      ),\n";
    
    $rws.="    ),\n";
  }
  $rws.="  ),\n";
  
  $rws.=");\n";
  $rws.="?>\n";
  return $rws;
}
// (7.A) form the rewritabale string of the given config array
function formCfgArrayRewriteString($pCfgArray)
{

  $rws="<?\n";
  $rws.="return array\n";
  $rws.="(\n";
  foreach ($pCfgArray as $levelOneKey => $levelOneValue)
  {
    if ($levelOneKey == "MAIN_MENU")
    {
      $rws.="  \"MAIN_MENU\" => array\n";
      $rws.="  (\n";
      $levelTwoArray=$levelOneValue;
      ksort($levelTwoArray);
      foreach($levelTwoArray as $levelTwoKey => $levelThreeArray)
      {
        $rws.="    $levelTwoKey => array\n";
      	$rws.="    (\n";
      	foreach ($levelThreeArray as $levelThreeKey => $levelThreeValue)
      	{
      	  if ($levelThreeKey == "SUB_MENU")
      	  {
      	    $rws.="      \"SUB_MENU\" => array\n";
      	    $rws.="      (\n";
	    $levelFourArray=$levelThreeValue;
	    ksort($levelFourArray);
      	    foreach($levelFourArray as $levelFourKey => $levelFiveArray)
      	    {
              $rws.="        $levelFourKey => array\n";
      	      $rws.="        (\n";
      	      foreach ($levelFiveArray as $levelFiveKey => $levelFiveValue)
      	      {
	      	$rws.=("          \"". $levelFiveKey ."\" => \"$levelFiveValue\", \n"); 
	      }
      	      $rws.="        ),\n";	      
	    }
      	    $rws.="      ),\n";
	  }
	  else
	  {
	    $rws.="      \"$levelThreeKey\" => \"$levelThreeValue\",\n"; 
	  }
	}
      	$rws.="    ),\n";
      }
      $rws.="  ),\n";
    }
    else
    {
      $rws.="  \"$levelOneKey\" => \"$levelOneValue\",\n";
    }
  }
  $rws.=");\n";
  $rws.="?>\n";
  return $rws;
}

// (7.B) rewrite the given config array as includable cfg-file into the given filename
function writeCfgFileContent($pFileName,$pCfgArray)
{
  global $gRelativeBuildPath;
  $cfgFilePath=($gRelativeBuildPath ."/" . $pFileName);
  
  //$cfgFileContent=formCfgArrayRewriteString($pCfgArray);
  $cfgFileContent=formCommentedCfgArrayRewriteString($pCfgArray);
  if (file_exists($cfgFilePath))
    copy($cfgFilePath,($cfgFilePath . ".bak"));
    
  $fd=fopen($cfgFilePath,"w");
  if ($fd)
  {
    fwrite($fd,$cfgFileContent);
    fclose($fd);
  }

}

// (7.C) rewrite the given config array as includable cfg-file into the actually valid cfg-file
function updateCfgFileContent($pCfgArray)
{
  writeCfgFileContent(getActuallyValidCfgFileName(),$pCfgArray);
}


// (8.A) form a list of all mainmenu entries
function formMmeIdList($pCfgArray)
{
  $mmeIdList=array();
  if ($pCfgArray["MAIN_MENU"])
  {
    ksort($pCfgArray["MAIN_MENU"]);
    foreach($pCfgArray["MAIN_MENU"] as $mmeAr)
    {
      array_push($mmeIdList,$mmeAr["MME_ID"]);
    }
  }
  ksort($mmeIdList);
  return $mmeIdList;
}

// (8.B) return the corresponding mainmenu-array
function getSpecificMmeArray($pCfgArray,$pMmeId,&$pMmeArrayKey)
{
  if ($pCfgArray["MAIN_MENU"])
  {
    foreach($pCfgArray["MAIN_MENU"] as $pMmeArrayKey => $mmeArray)
    {
      if ($pMmeId == $mmeArray["MME_ID"])
      {
      	return $mmeArray;
      }
    }
  }  
  return array();
}

// (9.A) form a list of all submenu entries
function formSmeIdList($pCfgArray,$pMmeId)
{
  $smeIdList=array();
  $mmeIdKey=-1;
  $mmeArray=getSpecificMmeArray($pCfgArray,$pMmeId,$mmeIdKey);
  ksort($mmeArray);
  if ($mmeArray)
  {
    if ($mmeArray["SUB_MENU"])
    {
      foreach($mmeArray["SUB_MENU"] as $smeArray)
      {
      	array_push($smeIdList,$smeArray["SME_ID"]);
      }
    }
  }
  return $smeIdList;
}

// (9.B) return the corresponding submenu-array
function getSpecificSmeArray($pMmeArray,$pSmeId,&$pSmeArrayKey)
{
  if ($pMmeArray["SUB_MENU"])
  {
    foreach($pMmeArray["SUB_MENU"] as $pSmeArrayKey => $smeArray)
    {
      if ($pSmeId == $smeArray["SME_ID"])
      {
      	return $smeArray;
      }
    }
  }  
  return array();
}

// (10) form the announce and change cfg-file line
function formActualCfgFileSignaler($pActCfgFile)
{

  $ln="";
  $ln.="<table border=\"0\" align=\"center\">\n";
  $ln.="<tr>\n";
  $ln.="  <td>\n";
  $ln.="    <font face=\"helvetica,arial\">\n";
  $ln.="      <span style=\"font-size:10pt;\">\n";
  $ln.="Actually selected LGSG configuration file is\n";
  $ln.="      </span>\n";
  $ln.="    </font>";
  $ln.="  </td>\n";
  $ln.="  <td>\n";
  $ln.="    <font face=\"helvetica,arial\">\n";
  $ln.="      <span style=\"font-size:10pt;\">\n";
  if ($pActCfgFile)
    $ln.=sprintf("<b>%s</b>\n",htmlentities($pActCfgFile));
  else
    $ln.="<b>unknown</b>\n";
  $ln.="      </span>\n";
  $ln.="    </font>";
  $ln.="  </td>\n";
  $ln.="  <td>\n";
  $ln.="    <font face=\"helvetica,arial\">\n";
  $ln.="      <span style=\"font-size:10pt;\">\n";
  $ln.="        <a href=\"../stc/select-site-cfg.php\">change</a>";
  $ln.="      </span>\n";
  $ln.="    </font>";
  $ln.="  </td>\n";
  
  $ln.="</tr>\n";
  $ln.="</table>\n";
  return $ln;
}

// (11.A) form an empty submenu entry
function formEmptySmeArray($pSiteId,$pMmeArrayKey,$pSmeArrayKey)
{
  global $smeFeatures;
  $smeArray=array();
  foreach ($smeFeatures as $smeFeatureArray)
  {
    $smeArray[$smeFeatureArray["key"]]=$smeFeatureArray["val"];
  }
  $smeArray["SME_ID"]="sme-(${pMmeArrayKey}-${pSmeArrayKey})";
  $smeArray["LINK_TARGET"]="sme-${pMmeArrayKey}-${pSmeArrayKey}.html";
  $smeArray["SME_TEXT"]="new empty submenu entry (${pMmeArrayKey}-${pSmeArrayKey})";
  return $smeArray;
}

// (11.B) form an empty mainmenu entry
function formEmptyMmeArray($pSiteId,$pMmeArrayKey)
{
  global $mmeFeatures;
  $mmeArray=array();
  foreach ($mmeFeatures as $mmeFeatureArray)
  {
    $mmeArray[$mmeFeatureArray["key"]]=$mmeFeatureArray["val"];
  }
  $mmeArray["MME_ID"]="mme-${pMmeArrayKey}";
  $mmeArray["MME_TEXT"]="new mainmenu entry (${pSiteId}-${pMmeArrayKey})";
  $mmeArray["SUB_MENU"][0]=formEmptySmeArray($pSiteId,$pMmeArrayKey,0);
  return $mmeArray;
}


// (11.C) form full new cfg array
function formNewLgspConfigurationFile($pSiteId)
{
  global $defFeatures;
  $cfgArray=array();
  foreach ($defFeatures as $featureArray)
  {
    $cfgArray[$featureArray["key"]]=$featureArray["val"];
  }
  $cfgArray["SITE_ID"]=$pSiteId;
  
  $cfgArray["MAIN_MENU"][0]=formEmptyMmeArray("$pSiteId",0);
  return $cfgArray;
}

// (11.D) search the next free index for inserting a new array/valu 
function findFreeIntIndex($pArray)
{
  if (!($pArray))
    return 0;
  $key=-1;
  foreach ($pArray as $key => $value)
  {
  }
  return ($key + 1);
}

// (12) write exchange dialog for any array
function formExchangeDialog($pArray,$pSubArrayKey,$pExchangeTarget,$meType,$mmeId="")
{
  if (!($pArray))
    return "";
    
  $ln="<div align=\"center\">";
  $ln.="<form action=\"${pExchangeTarget}\" method=\"get\" target=\"_self\">\n";
  $ln.="<table align=\"center\" border=\"0\"  cellpadding=\"1\" cellspacing=\"1\">\n";
  $ind=0;
  ksort($pArray);
  foreach($pArray as $key => $subarray)
  {
    $ln.="  <tr>\n";
    $ln.="    <td align=\"left\"><span style=\"font-size:12pt\"><font face=\"helvetica,arial\">move $meType</font><span></td>\n";
    $ln.=sprintf
    ( "    <td align=\"center\"><span style=\"font-size:12pt\"><font face=\"helvetica,arial\"><b>%s</b></font></span></td>\n",
      htmlentities($subarray[$pSubArrayKey]));
    $ln.="    <td align=\"right\"><span style=\"font-size:12pt\"><font face=\"helvetica,arial\">from place</font><span></td>\n";
    $ln.="    <td align=\"right\"><span style=\"font-size:12pt\"><font face=\"helvetica,arial\"><b>$key</b></font><span></td>\n";
    $ln.="    <td align=\"center\"><span style=\"font-size:12pt\"><font face=\"helvetica,arial\"><b>=></b></font><span></td>\n";
    $ln.="    <td align=\"left\">\n";
    $ln.="      <input type=\"hidden\" name=\"OAI${ind}\" value=\"${key}\">\n";
    $ln.="      <input type=\"text\" name=\"NAI${ind}\" value=\"${ind}\" size=\"2\" maxsize=\"4\">\n";
    $ln.="    </td>\n";
    $ln.="  </tr>\n";
    $ind+=1;
   
  }
  $ln.="  <tr>\n";
  $ln.="    <td colspan=\"6\" align=\"center\">";
  $ln.="      <input type=\"submit\" value=\"Change\">\n";
  $ln.="      <input type=\"reset\" value=\"Cancel\">\n";
  $ln.="      <input type=\"hidden\" name=\"HOW_MANY_ARRAY_FIELDS\" value=\"${ind}\">\n";
  if ($mmeId)
    $ln.="      <input type=\"hidden\" name=\"SEL_MME_ID\" value=\"${mmeId}\">\n";
  
  $ln.="    </td>\n";
  $ln.="  </tr>\n";
  
  $ln.="</table>\n";
  $ln.="</form>\n";
  $ln.="</div>\n";
  return $ln;
}
?>
