#!/usr/bin/php -q
<?

// Copyright (C) 2003, 2004, 2005, 2006 Karsten Reincke <karsten.reincke@fodina.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// file <lgsp.php> version <#2.0.0#> of project <lgsp>

include("../inc/lgsp-def.inc");

$gLgspConfigurationFile="lgsp.cfg.inc";
$gVersionString="<#2.0.0#>";

for ($i=1; $i<sizeof($argv); $i++)
{
  if (($argv[$i]=="-h")||($argv[$i]=="-v"))
  {
    printCmdlHV();
    exit(0);
  }
  else
    $gLgspConfigurationFile=$argv[$i];
}

if ($LGSP_CONFIGURATION_FILE)
  $gLgspConfigurationFile=$LGSP_CONFIGURATION_FILE;

if ($LGSP_REWRITE_TARGET_FILES=="true")
  $gRewriteTargetFiles=true;
else
  $gRewriteTargetFiles=false;
  
  
if ($LGSP_RETURN_TARGET)
  $gLgspReturnTarget="$LGSP_RETURN_TARGET";
else
  $gLgspReturnTarget="";
  
$gCssFileName="frame.css";

startHtmlLogging();
print(formHtmlHV());

if (!(file_exists($gLgspConfigurationFile)))
{
  sendHtmlErrorMessage(("can't open lgsp-configuration-file <" .$gLgspConfigurationFile . ">"));
  finishHtmlLogging();
  exit(-1);
}

$gSiteConfig=include("$gLgspConfigurationFile");


// (1) general determiner
$gSiteImgDir=($gSiteConfig["SITE_ID"] . "/" . $gSiteConfig["IMG_DIR"]);
// print("$gSiteImgDir\n");


$gSiteCssDir=($gSiteConfig["SITE_ID"] . "/" . $gSiteConfig["CSS_DIR"]);
// print("$gSiteCssDir\n");

// (2) generate same main directories

sendHtmlActionMessage("generating the multiply used site directories\n");

if (!(generateDirectoryIfMissed($gSiteConfig["SITE_ID"])))
{
  sendHtmlErrorMessage("cant create <" .  getcwd() . "/" . $gSiteConfig["SITE_ID"] .">\n");
  finishHtmlLogging();
  exit(-1);
}


if (!(generateDirectoryIfMissed($gSiteImgDir)))
{
  sendHtmlErrorMessage("cant create <" .  getcwd() . "/" . $gSiteImgDir .">\n");
  finishHtmlLogging();
  exit(-1);
}

if (!(generateDirectoryIfMissed($gSiteCssDir)))
{
  sendHtmlErrorMessage("cant create <" .  getcwd() . "/" . $gSiteCssDir .">\n");
  finishHtmlLogging();
  exit(-1);
}

ksort($gSiteConfig["MAIN_MENU"]);
// (2) do for all entries of the main menu
foreach($gSiteConfig["MAIN_MENU"] as $key => $mmeArray)
{

  // (2.A) for each entry of the mainmmenu 
  // there must be given a correspondign directory
  $mmeId=$mmeArray["MME_ID"];
  $mmeDir=($gSiteConfig["SITE_ID"] . "/" . $mmeId);
  
  sendHtmlActionMessage("generating directory for <" .$mmeArray["MME_ID"] . ">");
  if (!(generateDirectoryIfMissed($mmeDir)))
  {
    sendHtmlErrorMessage("cant create <" .  getcwd() . "/" .$mmeDir .">\n");
    finishHtmlLogging();
    exit(-1);
  }
 
  sendHtmlActionMessage("trying to write index file for <" .$mmeArray["MME_ID"] . ">");
  writeIndexFile($mmeDir,$mmeArray);

  sendHtmlActionMessage("trying to write logo file for <" .$mmeArray["MME_ID"] . ">");
  writeLogoFile($mmeDir,$mmeArray);
  
  sendHtmlActionMessage("trying to write mainmenufile for <" .$mmeArray["MME_ID"] . ">");
  writeMenuFile($mmeDir,$mmeArray);

  sendHtmlActionMessage("trying to write submenufile for <" .$mmeArray["MME_ID"] . ">");
  writeGuideFile($mmeDir,$mmeArray);
  
  sendHtmlActionMessage("trying to write missed targetfiles for <" .$mmeArray["MME_ID"] . ">");
  writeContentFiles($mmeDir,$mmeArray);

  sendHtmlActionMessage("trying to write basic style-sheet for <" .$mmeArray["MME_ID"] . ">");
  writeStyleSheet($mmeDir,$mmeArray);

}

sendHtmlActionMessage("trying to write top index file");
writeTopIndexFile();


finishHtmlLogging();
exit;

/*** (II) functions, used by the main loop ***/

/**
 *  (II.1) generates still missed directories
 */
function generateDirectoryIfMissed($pDir)
{
  
  if (!(($pDir)) || ($pDir == ""))
    return false;
  if (file_exists($pDir))
    return true;
  return mkdir($pDir,0777);
}

/**
 *  (II.2) writes the index-file into the given mme-Directory
 */


function writeIndexFile($pMmeDir,$pMmeConfArray,$pShallFilePrefix="")
{
  global $gSiteConfig;
  global $gCssFileName;

  $filePrefix="";
  if ($pShallFilePrefix!="")
    $filePrefix=($pShallFilePrefix."/");
    
  $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
  
  $ifContent=formPageHeader(true,$actuallyMergedCfgArray,$gCssFileName);

  reset($pMmeConfArray["SUB_MENU"]);
  $defSmeArray=current($pMmeConfArray["SUB_MENU"]);
  if ($defSmeArray)
    $defTarget=($defSmeArray["LINK_TARGET"]);
  else
    $defTargete="";
   
  $ifContent.=("<frameset rows=\"" .$actuallyMergedCfgArray["MENU_AREA_HEIGHT"]. ",*\" border=\"0\">\n");
  
  if ((strtolower($actuallyMergedCfgArray["WITH_LOGO_CORNER"]))=="no")
  {
    $ifContent.=("    <frame src=\"$filePrefix".formMainMenuPageFileName($actuallyMergedCfgArray) .
                 "\" name=\"menu\" noresize=\"noresize\" frameborder=\"0\" />\n"
	        );
  }
  else
  {
    $ifContent.=("  <frameset cols=\"" .$actuallyMergedCfgArray["GUIDE_AREA_WIDTH"]. ",*\" border=\"0\">\n");
    $ifContent.=("    <frame src=\"$filePrefix". formLogoPageFileName($actuallyMergedCfgArray) .
        	       "\" name=\"logo\" noresize=\"noresize\" frameborder=\"0\" />\n"
	        );
    $ifContent.=("    <frame src=\"$filePrefix".formMainMenuPageFileName($actuallyMergedCfgArray) .
                 "\" name=\"menu\" noresize=\"noresize\" frameborder=\"0\" />\n"
	        );
    $ifContent.="  </frameset>\n";
  }
  $ifContent.=("  <frameset cols=\"" .$actuallyMergedCfgArray["GUIDE_AREA_WIDTH"]. ",*\" border=\"0\">\n");
  $ifContent.=("    <frame src=\"$filePrefix".  formSubMenuPageFileName($actuallyMergedCfgArray) .
               "\" name=\"guide\" noresize=\"noresize\" frameborder=\"0\" />\n"
	      );
  $ifContent.="    <frame src=\"$filePrefix". $defTarget ."\" name=\"content\" frameborder=\"0\" />\n";
  $ifContent.="  </frameset>\n";
  $ifContent.="  <noframes>\n";
  $ifContent.=("    "  . formBodyTag($actuallyMergedCfgArray));
  $ifContent.=( "      <h1>\n" . 
      	        htmlentities( $actuallyMergedCfgArray["TITLE"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) . 
	       "\n      </h1>\n"
	      );
  $ifContent.=( "      <p>\n". 
      	      	htmlentities($actuallyMergedCfgArray["ABSTRACT"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]). 
		"\n      </p>\n"
	      );
  $ifContent.=( "      <p>\n" . 
      	      	htmlentities($actuallyMergedCfgArray["DESCRIPTION"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]). 
		"\n      </p>\n"
	      );
  $ifContent.=( "      <p>\n".
      	      	"Leider unterst&uuml;tzt ihr Browser keine Frames.\n" .
              	"Den direkten Zugriff erlaubt die Seite\n" .
		"<a href=\"$filePrefix".formSubMenuPageFileName($actuallyMergedCfgArray)."\">". 
		formSubMenuPageFileName($actuallyMergedCfgArray) . "</a>\n" .
		"      </p>\n"
	      ); 
  $ifContent.=( "      <p>\n".
      	      	"We are sorry. Your browser doesn't support frames.\n" .
              	"For a direct access use page\n" .
		"<a href=\"$filePrefix".formSubMenuPageFileName($actuallyMergedCfgArray)."\">". 
		formSubMenuPageFileName($actuallyMergedCfgArray) . "</a>\n" .
		"      </p>\n"
	      ); 
  $ifContent.="    </body>\n";

  $ifContent.="  </noframes>\n";
  $ifContent.="</frameset>\n";
  $ifContent.="</html>\n";

  if (!(writePage($pMmeDir,formIndexPageFileName($actuallyMergedCfgArray),$ifContent)))
  {
    sendHtmlErrorMessage
    ( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . formIndexPageFileName($actuallyMergedCfgArray) .">");
    return false;
  }
  
  sendHtmlSuccessMessage
  ( getcwd() . "/" .$pMmeDir ."/" . formIndexPageFileName($actuallyMergedCfgArray) .">");
  return true;
}

/**
 *  (II.3) writes the logo-file into the given mme-Directory
 */
 
function writeLogoFile($pMmeDir,$pMmeConfArray)
{
  global $gCssFileName;
    
  $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
  
  $lfContent=formPageHeader(false,$actuallyMergedCfgArray,$gCssFileName,($pMmeConfArray["MME_ID"] . ": logo"));

  $lfContent.=formBodyTag($actuallyMergedCfgArray,"logo");

  if ($actuallyMergedCfgArray["LOGO"])
  {

    $imgSizeStr="";
    $imgTag=formImgTag
    ( 
      ($pMmeConfArray["MME_ID"] . "_logo"),
      $actuallyMergedCfgArray["LOGO"],
      $actuallyMergedCfgArray,
      $imgSizeStr,
      $actuallyMergedCfgArray["TITLE"],
      $pIndent="      "
    );
  
   
    $lfContent.="<div align=\"center\">\n";
    $lfContent.="<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n";
    
    if ($actuallyMergedCfgArray["LOGO_TOP_MARGIN"])
    {
      $lfContent.=sprintf( "  <tr><td height=\"%s\" /></tr>\n",$actuallyMergedCfgArray["LOGO_TOP_MARGIN"]);
    }
    
    $lfContent.="  <tr>\n";
    $lfContent.="    <td $imageSizeStr>\n";
    $lfContent.=$imgTag; 
    $lfContent.="\n    </td>\n";
    $lfContent.="  </tr>\n";
    $lfContent.="</table>\n";
    $lfContent.="</div>\n";

  }
  
  $lfContent.="</body>\n";
  $lfContent.="</html>\n";
  
  
  if (!(writePage($pMmeDir,formLogoPageFileName($actuallyMergedCfgArray),$lfContent)))
  {
    sendHtmlErrorMessage
    ( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . formLogoPageFileName($actuallyMergedCfgArray) .">");
    return false;
  }
  
  sendHtmlSuccessMessage
  ( getcwd() . "/" .$pMmeDir ."/" . formLogoPageFileName($actuallyMergedCfgArray) .">");
  return true;
}

/**
 *  (II.4) writes the menu-file into the given mme-Directory
 */

function writeMenuFile($pMmeDir,$pMmeConfArray)
{

  global $gSiteConfig;
  global $gCssFileName;
  
  $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
  
  $mfContent=formPageHeader(false,$actuallyMergedCfgArray,$gCssFileName,($pMmeConfArray["MME_ID"] . ": menu"));

  $mfContent.="\n";
  $mfContent.="<!-- script for mouseover buttons -->\n";
  $mfContent.="<script language=\"JavaScript\">\n";
  $mfContent.="<!-- hide from none JavaScript Browsers\n";

  foreach($gSiteConfig["MAIN_MENU"] as $loopMmeConfArray)
  {

    if ($loopMmeConfArray["ENABLED_BUTTON"])
    {

      $mfContent.=declareMmeJavaIcon
      ( $loopMmeConfArray["MME_ID"],
      	"enabled",
      	$loopMmeConfArray["ENABLED_BUTTON"],
	$actuallyMergedCfgArray["IMG_DIR"]
      );
  
      $mfContent.=declareMmeJavaIcon
      ( $loopMmeConfArray["MME_ID"],
      	"mouseover",
      	$loopMmeConfArray["MOUSEOVER_BUTTON"],
	$actuallyMergedCfgArray["IMG_DIR"]
      );
  
      $mfContent.=declareMmeJavaIcon
      ( $loopMmeConfArray["MME_ID"],
      	"mousedown",
      	$loopMmeConfArray["MOUSEDOWN_BUTTON"],
	$actuallyMergedCfgArray["IMG_DIR"]
      );
  
      $mfContent.=declareMmeJavaIcon
      ( $loopMmeConfArray["MME_ID"],
      	"disabled",
      	$loopMmeConfArray["DISABLED_BUTTON"],
	$actuallyMergedCfgArray["IMG_DIR"]
      );
    }
  }

  $mfContent.="var the_image\n";
  $mfContent.="function Swap(image_name,the_image) \n";
  $mfContent.="{\n";
  $mfContent.="  image_name.src = the_image.src; return true;\n";
  $mfContent.="}\n";

  $mfContent.="// - stop hiding -->\n";
  $mfContent.="</script>\n";

  $mfContent.=formBodyTag($actuallyMergedCfgArray,"mainmenu");

  $numberOfMenuEntries=sizeof($gSiteConfig["MAIN_MENU"]);

  $bgStripSize="0";
  if ($actuallyMergedCfgArray["MME_BGSTRIPE_SIZE"])
    $bgStripSize=$actuallyMergedCfgArray["MME_BGSTRIPE_SIZE"];
  
  $mfContent.="<table border=\"0\" valign=\"middle\" align=\"center\" cellpadding=\"$bgStripSize\" cellspacing=\"0\">\n";

   
  /* (a) insert top-border:menu-table-distance */
  if (	($actuallyMergedCfgArray["MAIN_MENU_TOP_MARGIN"])
    &&	($actuallyMergedCfgArray["MAIN_MENU_TOP_MARGIN"]!="0")
    )
  {
    $mfContent.="  <tr>\n"; 
    $mfContent.=sprintf
    ( "    <td colspan=\"%s\" align=\"center\" height=\"%s\" />\n",
      $numberOfMenuEntries,
      $actuallyMergedCfgArray["MAIN_MENU_TOP_MARGIN"]
    ); 
    $mfContent.="  </tr>\n";
    
  }
 
  /* (b) insert headline or headpicture */
  if ($actuallyMergedCfgArray["HEADPICTURE"])
  {
    $imageSizeStr="";
    
    $imageTag=formImgTag
    ( ($actuallyMergedCfgArray["MME_ID"] ."_headpicture"),
      $actuallyMergedCfgArray["HEADPICTURE"],
      $actuallyMergedCfgArray,
      $imageSizeStr,
      $actuallyMergedCfgArray["HEADLINE"]
    );
 
    $mfContent.="  <tr>\n"; 
    $mfContent.="    <td colspan=\"$numberOfMenuEntries\" align=\"center\">\n";
    if (strpos($actuallyMergedCfgArray["HEADLINE"],"/"))
    {
      $mfContent.=sprintf
      	("      <a href=\"%s\" target=\"_top\">%s</a>\n",
	  $actuallyMergedCfgArray["HEADLINE"],
	  $imageTag);
    }
    else
      $mfContent.=("      " . $imageTag . "\n");
    
   $mfContent.="    </td>\n";      
    $mfContent.="  </tr>\n";
  }
  elseif($actuallyMergedCfgArray["HEADLINE"])
  {
    $mfContent.="  <tr>\n";
    $mfContent.="    <td colspan=\"$numberOfMenuEntries\" align=\"center\">\n";
    
    $htmlPreparedMmEntry=formMainMenuEntry
    ( "      ",
      11,
      ( "<b>" .
      	htmlentities($actuallyMergedCfgArray["HEADLINE"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) .
	"</b>"
      )
    );
    
    if (strpos($actuallyMergedCfgArray["HEADLINE"],"/"))
    {
      $mfContent.=sprintf
      ( "      <a href=\"%s\" target=\"_top\">%s</a>\n",
      	$actuallyMergedCfgArray["HEADLINE"],
	$htmlPreparedMmEntry
      );
    }
    else
    {
      $mfContent.=("    "  .  $htmlPreparedMmEntry  . "\n");  
    }
    
    $mfContent.="    </td>\n"; 
    $mfContent.="  </tr>\n";
    if ($actuallyMergedCfgArray["ENABLED_BUTTON"])
      $mfContent.=sprintf( "     <tr><td colspan=\"%s\" height=\"4\" /></tr>\n",$numberOfMenuEntries); 
  }
 
  /* (c) insert menu-entry -buttons / -texts */
 
  $mfContent.="  <tr>\n";  
  foreach($gSiteConfig["MAIN_MENU"] as $key => $loopMmeArray)
  {

    if ($loopMmeArray["ENABLED_BUTTON"])
    {
      $imageTag="";
      $imageSize="";
      if ($loopMmeArray["MME_ID"]==$actuallyMergedCfgArray["MME_ID"])
      {
      	$imageFileName="";
      	if ($loopMmeArray["DISABLED_BUTTON"])
	  $imageFileName=$loopMmeArray["DISABLED_BUTTON"];
	else
	  $imageFileName=$loopMmeArray["ENABLED_BUTTON"];
	
	$imageTag=formImgTag
	( ($loopMmeArray["MME_ID"] . "_button"),
	  $imageFileName,
	  $actuallyMergedCfgArray,
	  $imageSize,
	  $loopMmeArray["ABSTRACT"],
	  "      "
	);
      	$bgColStr="";
	if ($loopMmeArray["MME_BGSTRIPE_COLOR"])
	  $bgColStr=sprintf("bgcolor=\"%s\"",$loopMmeArray["MME_BGSTRIPE_COLOR"]);
      	$mfContent.="    <td align=\"center\" $imageSize $bgColStr>\n";
	$mfContent.=$imageTag;
	$mfContent.="\n    </td>\n";	
      }
      else
      {
	
	$imageTag=formImgTag
	( ($loopMmeArray["MME_ID"] . "_button"),
	  $loopMmeArray["ENABLED_BUTTON"],
	  //$imageFileName=$loopMmeArray["ENABLED_BUTTON"],
	  $actuallyMergedCfgArray,
	  $imageSize,
	  $loopMmeArray["ABSTRACT"]
	);

      	$bgColStr="";
	if ($actuallyMergedCfgArray["MME_BGSTRIPE_COLOR"])
	  $bgColStr=sprintf("bgcolor=\"%s\"",$actuallyMergedCfgArray["MME_BGSTRIPE_COLOR"]);
      	
      	$mfContent.="    <td align=\"center\" $imageSize $bgColStr>\n";
      	$mfContent.=sprintf
        ( "      <a href=\"../%s/%s\" target=\"_parent\"\n",
      	  $loopMmeArray["MME_ID"],
      	  formIndexPageFileName(collectActuallyValidConfigParameters($loopMmeArray,0))
        );
	
      	$mfContent.=sprintf
	( "         onMouseOver=\"Swap(%s_button,%s_mouseover_icon)\"\n",
	  $loopMmeArray["MME_ID"],
	  $loopMmeArray["MME_ID"]  
	);
      	$mfContent.=sprintf
	( "         onMouseOut=\"Swap(%s_button,%s_enabled_icon)\"\n",
	  $loopMmeArray["MME_ID"],
	  $loopMmeArray["MME_ID"]  
	);

      	$mfContent.=sprintf
	( "         onMouseDown=\"Swap(%s_button,%s_mousedown_icon); return true;\"\n",
	  $loopMmeArray["MME_ID"],
	  $loopMmeArray["MME_ID"]  
	);
	$mfContent.="      >\n";
	$mfContent.=$imageTag;
	$mfContent.="</a>\n";	
	$mfContent.="    </td>\n";	
      }
    }
    else
    {
      $bgColStr="";
      if ($actuallyMergedCfgArray["MME_BGSTRIPE_COLOR"])
	  $bgColStr=sprintf("bgcolor=\"%s\"",$actuallyMergedCfgArray["MME_BGSTRIPE_COLOR"]);
      $mfContent.="    <td align=\"center\" $bgColStr>\n";
      $mfContent.=sprintf
       ( "      <a href=\"../%s/%s\" target=\"_parent\">\n",
      	  $loopMmeArray["MME_ID"],
      	  formIndexPageFileName(collectActuallyValidConfigParameters($loopMmeArray,0))
       );
    
      $mfContent.=formMainMenuEntry
      ( "      ",
      	12,
      	( "<b>" .
      	  htmlentities($loopMmeArray["MME_TEXT"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) .
	  "</b>"
      	)
      );
      $mfContent.="\n      </a>\n";
      $mfContent.="    </td>\n";
    }
  }
  $mfContent.="  </tr>\n";

 
  /* (d) insert subline or subpicture */
  if ($actuallyMergedCfgArray["SUBPICTURE"])
  {
    $imageSizeStr="";
    
    $imageTag=formImgTag
    ( ($actuallyMergedCfgArray["MME_ID"] ."_subpicture"),
      $actuallyMergedCfgArray["SUBPICTURE"],
      $actuallyMergedCfgArray,
      $imageSizeStr,
      $actuallyMergedCfgArray["SUBLINE"]
    );

    $mfContent.="  <tr>\n"; 
    $mfContent.="    <td colspan=\"$numberOfMenuEntries\" align=\"center\">\n";
     if (strpos($actuallyMergedCfgArray["SUBLINE"],"/"))
    {
      $mfContent.=sprintf
      	("      <a href=\"%s\">%s</a>\n",
	  $actuallyMergedCfgArray["SUBLINE"],
	  $imageTag);
    }
    else
      $mfContent.=("      " . $imageTag . "\n");
    
    $mfContent.="    </td>\n";      
    $mfContent.="  </tr>\n";
  }
  elseif($actuallyMergedCfgArray["SUBLINE"])
  {
    if ($actuallyMergedCfgArray["ENABLED_BUTTON"])
      $mfContent.=sprintf( "     <tr><td colspan=\"%s\" height=\"4\" /></tr>\n",$numberOfMenuEntries); 
    $mfContent.="  <tr>\n";
    $mfContent.="    <td colspan=\"$numberOfMenuEntries\" align=\"center\">\n";
    
    $htmlPreparedMmEntry=formMainMenuEntry
    ( "      ",
      10,
      ( "<b><i>" .
      	htmlentities($actuallyMergedCfgArray["SUBLINE"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) .
	"</i></b>"
      )
    );
    
    if (strpos($actuallyMergedCfgArray["SUBLINE"],"/"))
    {
      $mfContent.=sprintf
      ( "      <a href=\"%s\">%s</a>\n",
      	$actuallyMergedCfgArray["SUBLINE"],
	$htmlPreparedMmEntry
      );
    }
    else
    {
      $mfContent.=("    "  .  $htmlPreparedMmEntry  . "\n");  
    }
    
    $mfContent.="    </td>\n"; 
    $mfContent.="  </tr>\n";

  }
  
  
  $mfContent.="</table>\n";
  
 
  //$mfContent.=generateMenuPageBody($pMmeArray);
 
 
  $mfContent.="</body>\n";
  $mfContent.="</html>\n";
 
 
  if (!(writePage($pMmeDir,formMainMenuPageFileName($actuallyMergedCfgArray),$mfContent)))
  {
    sendHtmlErrorMessage
    ( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . formMainMenuPageFileName($actuallyMergedCfgArray) .">");
    return false;
  }
  sendHtmlSuccessMessage
  ( getcwd() . "/" .$pMmeDir ."/" . formMainMenuPageFileName($actuallyMergedCfgArray) .">");
  return true;
}

/**
 *  (II.4.a) declares a java script icon
 */
function declareMmeJavaIcon($pMmeId,$pIconType,$pIconName,$pImageDir)
{
  global $gSiteConfig;

  if (!($pIconName))
    return "";
  $pp=sprintf("  %s_%s_icon=new Image();\n",$pMmeId,$pIconType);
  $pp.=sprintf
  ( "  %s_%s_icon.src=\"../%s/%s\";\n",
    $pMmeId,
    $pIconType,
    $pImageDir,
    $pIconName
  );
  return $pp;
}

/**
 *  (II.4.b) generate a textual menu entry
 */
function formMainMenuEntry($indent,$pFontSize,$pText)
{
  $pp="$indent<span style=\"font-size:${pFontSize}pt;\">\n";
  $pp.="$indent  <font face=\"Helvetica, Tahoma, Arial, sans-serif\">$pText</font>\n";
  $pp.="$indent</span>\n";
  
  return $pp;
}

/**
 *  (II.5) writes the guide-file into the given mme-Directory
 */
function writeGuideFile($pMmeDir,$pMmeConfArray)
{

  global $gSiteConfig;
  global $gCssFileName;

  $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
 
  $gfContent=formPageHeader(false,$actuallyMergedCfgArray,$gCssFileName,($actuallyMergedCfgArray["MME_ID"] . ": guide"));

  $gfContent.="\n";
  $gfContent.="<!-- script for mouseover buttons -->\n";
  $gfContent.="<script language=\"JavaScript\">\n";
  $gfContent.="<!-- hide from none JavaScript Browsers\n";

  if (( $actuallyMergedCfgArray["MME_MOUSEOVER_MARKER"])&&( $actuallyMergedCfgArray["MME_MARKER"]))
  {
    $gfContent.=declareMmeJavaIcon
      ( "guide",
        "enabled", 
        $actuallyMergedCfgArray["MME_MARKER"],
         $actuallyMergedCfgArray["IMG_DIR"]
      );

     $gfContent.=declareMmeJavaIcon
       ( "guide",
        "mouseover",
        $actuallyMergedCfgArray["MME_MOUSEOVER_MARKER"],
        $actuallyMergedCfgArray["IMG_DIR"]
       );
  }

  $gfContent.="var the_image\n";
  $gfContent.="function Swap(image_name,the_image) \n";
  $gfContent.="{\n";
  $gfContent.="  image_name.src = the_image.src; return true;\n";
  $gfContent.="}\n";

  $gfContent.="// - stop hiding -->\n";
  $gfContent.="</script>\n";

  $gfContent.=formBodyTag($actuallyMergedCfgArray,"submenu");

  $gfContent.="<div align=\"left\">\n";
  $gfContent.="<table border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\n";

  $sizeStr="";
 


  foreach($gSiteConfig["MAIN_MENU"] as $key => $topMmeArray)
  {
   
    if ($topMmeArray["MME_ID"]==$actuallyMergedCfgArray["MME_ID"])
    {


      $gfContent.="  <tr>\n";
      $gfContent.="    <td align=\"center\" $sizeStr>\n";
      
      if ($actuallyMergedCfgArray["MME_MARKER"])
      {
         $mmeMarkerTag=formImgTag
        ( ($actuallyMergedCfgArray["MME_ID"] . "_button"),
          $actuallyMergedCfgArray["MME_MARKER"],
          $actuallyMergedCfgArray,
          $sizeStr,
          htmlentities($topMmeArray["MME_TEXT"])      
        );
     	$gfContent.=("      "  . $mmeMarkerTag . "\n");
      }
      else
      {
      	$gfContent.=formSubMenuAreaEntry("      ",12,"&raquo;");
      }
      $gfContent.="    </td>\n";
      $gfContent.="    <td>\n";
      $gfContent.=formSubMenuAreaEntry
      	( "      ",
	  11,
	  ( "<b>" .
	    htmlentities($topMmeArray["MME_TEXT"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) .
	    "</b>"
	  )
	);
      $gfContent.="    </td>\n";
      $gfContent.="  </tr>\n";
      $gfContent.="  <tr>\n";
      $gfContent.="    <td align=\"center\">\n";
      $gfContent.="      &nbsp;\n";
      $gfContent.="    </td>\n";
      $gfContent.="    <td>\n";
      $gfContent.=formSubMenuAreaSubMenuTable($topMmeArray,$actuallyMergedCfgArray);
      $gfContent.="    </td>\n";
      $gfContent.="  </tr>\n";
      
    }
    else
    {
      $gfContent.="  <tr>\n";
      $gfContent.="    <td align=\"center\">\n";
      if ($actuallyMergedCfgArray["MME_MARKER"])
      {
      	$gfContent.=sprintf
        ( "      <a href=\"../%s/%s\" target=\"_parent\"\n",
      	  $topMmeArray["MME_ID"],
      	  formIndexPageFileName(collectActuallyValidConfigParameters($topMmeArray,0))
        );
        
        if ($actuallyMergedCfgArray["MME_MOUSEOVER_MARKER"])
        {
      	  $gfContent.=sprintf
	  ( "         onMouseOver=\"Swap(%s_button,guide_mouseover_icon)\"\n",
	    $topMmeArray["MME_ID"] 
	  );
      	  $gfContent.=sprintf
	  ( "         onMouseOut=\"Swap(%s_button,guide_enabled_icon)\"",
	    $topMmeArray["MME_ID"] 
	  );
          
        }
        
        $gfContent.=">\n";
                
        $mmeMarkerTag=
          formImgTag
            ( ($topMmeArray["MME_ID"] . "_button"),
              $actuallyMergedCfgArray["MME_MARKER"],
              $actuallyMergedCfgArray,
              $sizeStr,
              htmlentities($topMmeArray["MME_TEXT"])
            );
      	  $gfContent.=("        "  . $mmeMarkerTag . "</a>\n");
        
      }
      else
      {
      	$gfContent.=formSubMenuAreaEntry("      ",12,"&raquo;");
      }
      $gfContent.="    </td>\n";
      $gfContent.="    <td>\n";
        
      $locallyMergedCfgArray=collectActuallyValidConfigParameters($topMmeArray,0);

      $gfContent.=sprintf
       ( "      <a href=\"../%s/%s\" target=\"_parent\">\n",
      	  $topMmeArray["MME_ID"],
      	  formIndexPageFileName($locallyMergedCfgArray)
       );
      $gfContent.=formSubMenuAreaEntry
      	( "        ",
	  11,
	  ( "<b>" .
	    htmlentities($topMmeArray["MME_TEXT"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"]) .
	    "</b>"
	  ) 
	);
      $gfContent.="      </a>\n";
      $gfContent.="    </td>\n";
      $gfContent.="  </tr>\n";
     
    }
  }
  if ($actuallyMergedCfgArray["WITH_IMPRESSUM"])
  {
    $gfContent.="  <tr><td colspan=\"2\" align=\"center\" height=\"16\"></td></tr>\n";
    $gfContent.="  <tr>\n";
    $gfContent.="    <td colspan=\"2\" align=\"center\">\n";
    $gfContent.="      <a href=\"impressum.html\" target=\"content\">\n";
    $gfContent.=formSubMenuAreaEntry( "        ",8,"impressum");
    $gfContent.="      </a>\n";
    $gfContent.="    </td>\n";
    $gfContent.="  </tr>\n";
  }
  $gfContent.="</table>\n";
  $gfContent.="</div>\n";
  
  $gfContent.="</body>\n";
  $gfContent.="</html>\n";
  
  if (!(writePage($pMmeDir,formSubMenuPageFileName($actuallyMergedCfgArray),$gfContent)))
  {
    sendHtmlErrorMessage
    ( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . formSubMenuPageFileName($actuallyMergedCfgArray) .">");
    return false;
  }
  sendHtmlSuccessMessage
  ( getcwd() . "/" .$pMmeDir ."/" . formSubMenuPageFileName($actuallyMergedCfgArray) .">");
   
  return true;
}

/**
 *  (II.5.a) generate a sub-menu-area-entry
 */

function formSubMenuAreaEntry($indent,$pFontSize,$pText)
{
  $pp="$indent<span style=\"font-size:${pFontSize}pt\">\n";
  $pp.="$indent  <font face=\"Helvetica, Tahoma, Arial, sans-serif\">$pText</font>\n";
  $pp.="$indent</span>\n";
  
  return $pp;
}

/**
 *  (II.5.b) generate a sub-menu-area-table
 */
function formSubMenuAreaSubMenuTable($pMmeConfArray,$pLocalCfgArray)
{
  $indent="      ";
  $pp.="$indent<table border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\n";
  
  ksort($pMmeConfArray["SUB_MENU"]);
  foreach($pMmeConfArray["SUB_MENU"] as $smeArray)
  {
  
    if (!($smeArray))
    {
      $pp.="$indent  <tr>\n";
      $pp.="$indent    <td colspan=\"2\" valign=\"middle\">\n";
      $pp.="$indent      <hr align=\"left\" size=\"1\" noshade=\"noshade\" />\n";
      $pp.="$indent    </td>\n";
      $pp.="$indent  </tr>\n";
    }
    else
    {
      $pp.="$indent  <tr>\n";
      $pp.="$indent    <td valign=\"middle\">\n";
      $pp.=formSubMenuAreaEntry(($indent."      "),9,"&raquo;");
      $pp.="$indent    </td>\n";
      $pp.="$indent    <td valign=\"middle\">\n";
      if (!($smeArray["LINK_TARGET_PLACE"]))
        $linkTargetPlace="content";
      else
        $linkTargetPlace=$smeArray["LINK_TARGET_PLACE"];
        
      $pp.=sprintf
      ( "$indent      <a href=\"%s\" target=\"%s\">\n",
      	$smeArray["LINK_TARGET"],
        $linkTargetPlace
      );
      $pp.=formSubMenuAreaEntry
      ( ($indent . "        "),
      	9,
      	( "" .
	  htmlentities($smeArray["SME_TEXT"],ENT_QUOTES,$pLocalCfgArray["ENCODING"]) .
	 "" 
	)
      );
      $pp.="$indent      </a>\n";
      $pp.="$indent    </td>\n";
      $pp.="$indent  </tr>\n"; 
    }    
  }
  $pp.="$indent</table>\n";
  return $pp;
}

/**
 *  (II.6) writes all corresponding content-files into the given mme-Directory
 */
function writeContentFiles($pMmeDir,$pMmeConfArray)
{
  global $gSiteConfig;
  global $gCssFileName;
  global $gRewriteTargetFiles;
  
  foreach($pMmeConfArray["SUB_MENU"] as $smeArray)
  {
    if ($smeArray)
    {
      	
      $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,$smeArray);
      
      if (!(strpos($actuallyMergedCfgArray["LINK_TARGET"],"/")))
      {
      
      	$fileName=($pMmeDir . "/" . $smeArray["LINK_TARGET"]);
      	if ((file_exists($fileName))&&(!($gRewriteTargetFiles)))
	{
      	  sendHtmlActionMessage
      	  ( "don't overwrite already existing target file: <" .getcwd() . "/" .$pMmeDir ."/" .$fileName .">");
	  
      	}
	else
	{
	  $specificCssFileName=($actuallyMergedCfgArray["SME_ID"].".css");
	  
 	  $cfContent=formPageHeader(false,$actuallyMergedCfgArray,$specificCssFileName);
	  $cfContent.=formBodyTag($actuallyMergedCfgArray,"page");
     	  $cfContent.=sprintf
      	  ( "  <h1>\n%s\n  </h1>\n",
	    htmlentities( $actuallyMergedCfgArray["TITLE"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"])
	  );
	  
     	  $cfContent.=sprintf
      	  ( "  <p>\n%s\n  </p>\n",
	    htmlentities( $actuallyMergedCfgArray["ABSTRACT"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"])
	  );

     	  $cfContent.=sprintf
      	  ( "  <p>\n%s\n  </p>\n",
	    htmlentities( $actuallyMergedCfgArray["DESCRIPTION"],ENT_QUOTES,$actuallyMergedCfgArray["ENCODING"])
	  );
   
      	  $cfContent.="<a href=\"http://localhost/index.html\"> example link </a>\n";
      	  $cfContent.="</body>\n";
      	  $cfContent.="</html>\n";
  
      	  if (!(writePage($pMmeDir,$actuallyMergedCfgArray["LINK_TARGET"],$cfContent)))
      	  {
      	    sendHtmlErrorMessage
      	    ( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . $actuallyMergedCfgArray["LINK_TARGET"] .">");
      	    return false;
      	  }
  
      	  writeSpecificStyleSheet($pMmeDir,$actuallyMergedCfgArray,$specificCssFileName);
      	  
	  sendHtmlSuccessMessage
      	  ( getcwd() . "/" .$pMmeDir ."/" . $actuallyMergedCfgArray["LINK_TARGET"] .">");

	}
      }
      else
      {
      	sendHtmlActionMessage
      	( "ignore external link: <" .$actuallyMergedCfgArray["LINK_TARGET"] .">");
      }
      
    }
  }
 
  if ((file_exists($pMmeDir . "/" ."impressum.html"))&&(!($gRewriteTargetFiles)))
    sendHtmlActionMessage
    ( "don't overwrite already existing target file: <" .getcwd() . "/" .$pMmeDir ."/" ."impressum.html>");
  else
  {    
    $impressumMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
    $ifContent=formPageHeader(false,$impressumMergedCfgArray,$gCssFileName);
    $ifContent.=formBodyTag($impressumMergedCfgArray);
    $ifContent.="<div align=\"center\">\n";
    $ifContent.="<h3>Impressum</h3>\n";
    $ifContent.="<p>\n";
    $ifContent.=
    ( sprintf
      ( "%s: <br /><b>%s</b>\n",
      	htmlentities("Inhaltlich Verantwortlich gem  6 MDStV"),
      	htmlentities($impressumMergedCfgArray["AUTHOR"])
      )
    );  
    $ifContent.="</p>\n";
    $ifContent.="<p>\n";
    $ifContent.=
    ( htmlentities
      ( "Trotz sorgfltiger inhaltlicher Kontrolle bernehmen " .
      	"wir keine Haftung fr die Inhalte externer Links. Fr den Inhalt " .
      	"der verlinkten Seiten sind ausschlielich deren Betreiber verantwortlich."
      )
    );  
    $ifContent.="</p>\n";
    
    $ifContent.="</div>\n";
    $ifContent.="</body>\n";
    $ifContent.="</html>\n";
  
    if (!(writePage($pMmeDir,"impressum.html",$ifContent)))
    {
      sendHtmlErrorMessage( "couldn't write: <" .getcwd() . "/" .$pMmeDir ."/" . "impressum.html" .">");
      return false;
    }
  
    sendHtmlSuccessMessage(getcwd() . "/" .$pMmeDir ."/" . "impressum.html>");
  }
  sendHtmlSuccessMessage
  ( "having created the still missed corresponding targetfiles");
  
  return true;
}

/**
 *  (II.8) writes the top index-file into the site directory
 */

function writeTopIndexFile()
{
  global $gSiteConfig;
  ksort($gSiteConfig["MAIN_MENU"]);
  reset($gSiteConfig["MAIN_MENU"]);
  $mmeArray=current($gSiteConfig["MAIN_MENU"]);
  writeIndexFile($gSiteConfig["SITE_ID"],$mmeArray,$mmeArray["MME_ID"]);
  
  return true;
}

/**
 *  (II.7) writes default style scheet
 */

function writeStyleSheet($pMmeDir,$pMmeConfArray)
{
  
  global $gCssFileName;
  global $gRewriteTargetFiles;
  
  $actuallyMergedCfgArray=collectActuallyValidConfigParameters($pMmeConfArray,0);
  
  $styleSheetDir=($pMmeDir . "/" . $actuallyMergedCfgArray["CSS_DIR"] );
  if (!(generateDirectoryIfMissed($styleSheetDir)))
  {
    sendHtmlErrorMessage("cant create <" .  getcwd() . "/" .$styleSheetDir .">\n");
    finishHtmlLogging();
    exit(-1);
  } 
  
  if ((file_exists(($styleSheetDir . "/" . $gCssFileName)))&&(!($gRewriteTargetFiles)))
  {
    sendHtmlActionMessage
    ( "don't overwrite already existing stylesheet file: <" 
      .getcwd() . "/" . $styleSheetDir ."/" .$gCssFileName .">"
    );
  }
  else
  {
    $csContent=sprintf("a:link { color: %s; }\n",$actuallyMergedCfgArray["LINK_COLOR"]);
    $csContent.=sprintf("a:visited { color: %s; }\n",$actuallyMergedCfgArray["VLINK_COLOR"]);
    $csContent.=sprintf("a:active{ color: %s; }\n",$actuallyMergedCfgArray["ALINK_COLOR"]);
    $csContent.=sprintf("a:hover{ color: %s; }\n",$actuallyMergedCfgArray["HOVER_COLOR"]);

    if (!(writePage($styleSheetDir,$gCssFileName,$csContent)))
    {
      sendHtmlErrorMessage( "couldn't write: <" .getcwd() . "/" .$styleSheetDir ."/" . $gCssFileName .">");
      return false;
    }
  
    sendHtmlSuccessMessage( getcwd() . "/" .$styleSheetDir ."/" . $gCssFileName .">");
  }
  return true;
}

function writeSpecificStyleSheet($pMmeDir,$pActuallyMergedCfgArray,$pSpecificCssFileName)
{
  global $gRewriteTargetFiles;
  
  $styleSheetDir=($pMmeDir . "/" . $pActuallyMergedCfgArray["CSS_DIR"] );
  if (!(generateDirectoryIfMissed($styleSheetDir)))
  {
    sendHtmlErrorMessage("cant create <" .  getcwd() . "/" .$styleSheetDir .">\n");
    finishHtmlLogging();
    exit(-1);
  } 

  if ((file_exists(($styleSheetDir . "/" . $pSpecificCssFileName)))&&(!($gRewriteTargetFiles)))
  {
    sendHtmlActionMessage
    ( "don't overwrite already existing stylesheet file: <" 
      .getcwd() . "/" . $styleSheetDir ."/" .$styleSheetDir . "/" . $pSpecificCssFileName .">"
    );
  }
  else
  {
    $csContent=sprintf("a:link { color: %s; }\n",$pActuallyMergedCfgArray["LINK_COLOR"]);
    $csContent.=sprintf("a:visited { color: %s; }\n",$pActuallyMergedCfgArray["VLINK_COLOR"]);
    $csContent.=sprintf("a:active{ color: %s; }\n",$pActuallyMergedCfgArray["ALINK_COLOR"]);
    $csContent.=sprintf("a:hover{ color: %s; }\n",$pActuallyMergedCfgArray["HOVER_COLOR"]);

    if (!(writePage($styleSheetDir,$pSpecificCssFileName,$csContent)))
    {
      sendHtmlErrorMessage( "couldn't write: <" .getcwd() . "/" .$styleSheetDir ."/" . $pSpecificCssFileName .">");
      return false;
    }
  
    sendHtmlSuccessMessage( getcwd() . "/" .$styleSheetDir ."/" . $pSpecificCssFileName .">");
  }
  return true;
}

/**
 *  (II.8) help screen for commandline call
 */

function printCmdlHV()
{
  global $gVersionString;
   print
   (  "lgsp.php [-v|-h] lgspSiteConfigurationFile\n\n" .
      "Little GNU Site Preparer release ${gVersionString}\n" .
      "Copyright (C) 2003, 2004, 2005, 2006 Karsten Reincke\n" .
      "lgsp comes with ABSOLUTELY NO WARRANTY. This\n" .
      "is free software, and you are welcome to use and\n" .
      "to redistribute it under the terms of the GNU\n" .
      "GNU General Public Licence as published by the\n" .
      "Free Software Foundation; either version 2 of the\n" .
      "Licence, or (at your opinion) any later version.\n"
   );
}

function formHtmlHV()
{
   return
   (  "lgsp.php [-v|-h] lgspSiteConfigurationFile<br />\n<br />\n" .
      "Little GNU Site Preparer release ${gVersionString}<br />\n" .
      "Copyright (C) 2003, 2004, 2005, 2006 Karsten Reincke<br />\n" .
      "lgsp comes with ABSOLUTELY NO WARRANTY. This<br />\n" .
      "is free software, and you are welcome to use and<br />\n" .
      "to redistribute it under the terms of the GNU<br />\n" .
      "GNU General Public Licence as published by the<br />\n" .
      "Free Software Foundation; either version 2 of the<br />\n" .
      "Licence, or (at your opinion) any later version.<br />\n<br />\n"
   );
}
/*** (III) functions, used by more than one of the main functions ***/


/**
 *  (III.A) collect the actually valid configuration parameters
 *
 *  merges the reachable configuration parameter
 *  and returns the set of all actually valid 
 *  atribute-value-pairs (= hash array)
 *
 *  \param $pMmeConfig :- main-menu-entry-config-array
 *  \param $pSmeConfig :- sub-menu-entry-config-array
 */
function collectActuallyValidConfigParameters
(
  $pMmeConfig,
  $pSmeConfig
)
{
  global $gSiteConfig;
  global $defFeatures;
  global $mmeFeatures;
  global $smeFeatures;
  
  $car=array();
  
  foreach( $defFeatures as $defEntryArray)
  {
    if ($defEntryArray["key"]!="DL")
      $car[$defEntryArray["key"]]=$defEntryArray["val"];
  
  }
  
  foreach( $mmeFeatures as $mmeEntryArray)
  {
    if (($mmeEntryArray["key"]!="DL")&&($mmeEntryArray["val"]!=""))
      $car[$mmeEntryArray["key"]]=$mmeEntryArray["val"];
  
  }
  
  foreach( $smeFeatures as $smeEntryArray)
  {
    if (($smeEntryArray["key"]!="DL")&&($smeEntryArray["val"]!=""))
      $car[$smeEntryArray["key"]]=$smeEntryArray["val"];
  
  }
  
  
  foreach($defFeatures as $defEntryArray)
  {
    if ($gSiteConfig[$defEntryArray["key"]]!="")
     $car[$defEntryArray["key"]]=$gSiteConfig[$defEntryArray["key"]];
  }
   
  if ($pMmeConfig)
  {
    foreach( $mmeFeatures as $mmeEntryArray)
    {
      if ($pMmeConfig[$mmeEntryArray["key"]]!="") 
        $car[$mmeEntryArray["key"]] = $pMmeConfig[$mmeEntryArray["key"]];    
    }
  }  


  /* (3) let the externally determined main-menu-entry defaults be overwritten
   * by the externally determined sub-menu-entry specific values */
 
  if ($pSmeConfig)
  {
    foreach( $smeFeatures as $smeEntryArray)
    {
      if ($pSmeConfig[$smeEntryArray["key"]]!="") 
        $car[$smeEntryArray["key"]] = $pSmeConfig[$smeEntryArray["key"]];    
    }
  }

  return $car;
}

/**
 *  (III.B) generate a valid page-header
 *
 *  creates page header section witzh respect to the given configuration array
 *  (undefined values will be ignored)
 */
function formPageHeader($pForFramesetPage,$pCfgArray,$pCssFileName,$pSpecialTitle="")
{

  $pp="";

  if (strtolower($pCfgArray["WRITE_XML_DECLARATION"])=="yes")
    $pp=("<?xml version=\"1.0\" encoding=\"" .$pCfgArray["ENCODING"] ."\" ?>\n");
  if ($pForFramesetPage)
  {
    $pp.=
    (
      "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Frameset//EN\" " .
      "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd\">\n"
    );
    
  }
  else
  {
    $pp.=
    (
      "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" " .
      "\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"
    );
  }
  
  $pp.="<html xmlns=\"http://www.w3.org/1999/xhtml\">\n";
  $pp.=sprintf
  ( "<link href=\"%s/%s\" rel=\"stylesheet\" type=\"text/css\">\n",
    $pCfgArray["CSS_DIR"],
    $pCssFileName
  );
  $pp.="<head>\n"; 
  
  
  $pp.=("  <meta http-equiv=\"content-type\" content=\"text/html; charset=" .
      	$pCfgArray["ENCODING"] .
      	"\" />\n"
       );
  
  if ($pCfgArray["ABSTRACT"] )
  { 
    $pp.=("  <meta name=\"description\" content=\"" .
      	  htmlentities($pCfgArray["ABSTRACT"]) .
      	  "\" />\n"
      	 );
  }
  
  if ($pCfgArray["AUTHOR"] )
  {   
    $pp.=("  <meta name=\"author\" content=\"" .
      	  htmlentities($pCfgArray["AUTHOR"]) .
      	  "\" />\n"
      	 );
  }
  
  if ($pCfgArray["KEYWORDS_FREE_LANGUAGE"])
  {
    $pp.=("  <meta name=\"keywords\" lang=\"" .
           htmlentities($pCfgArray["KEYWORDS_FREE_LANGUAGE"]) .
	  "\" content=\"".
	  htmlentities($pCfgArray["KEYWORDS_FREE"]) .
	  "\" />\n"
      	);
  }
  
  if ($pCfgArray["KEYWORDS_EN"])
  {
    $pp.=("  <meta name=\"keywords\" lang=\"en\" content=\"" .
      	  htmlentities($pCfgArray["KEYWORDS_EN"]).
	  "\" />\n"
         );
  }
  
  $pp.="  <meta name=\"date\" content=\"".date("Y-m-d-\T-H-i-s") ."\" />\n";
  $pp.="  <meta name=\"robots\" content=\"follow\" />\n";
  
  if ($pSpecialTitle!="")
    $pp.=("  <title>".$pSpecialTitle."</title>\n");
  elseif ($pCfgArray["TITLE"])
    $pp.="  <title>".$pCfgArray["TITLE"]."</title>\n";
  else
    $pp.="  <title>???</title>\n";

  $pp.="</head>\n";
  return $pp;
}

/**
 *  (III.C.a) generate index-page-file-name
 */
function formIndexPageFileName($pLocalCfgArray)
{
  return ($pLocalCfgArray["INTRO_MARKER"] . ".html");
}


/**
 *  (III.C.b) generate logo-page-file-name
 */
function formLogoPageFileName($pLocalCfgArray)
{
  return ($pLocalCfgArray["LOGO_MARKER"] . ".html");
}

/**
 *  (III.C.c) generate main-menu-page-file-name
 */
function formMainMenuPageFileName($pLocalCfgArray)
{
  return ($pLocalCfgArray["MENU_MARKER"] . ".html");
}

/**
 *  (III.C.d) generate submenu-page-file-name
 */
function formSubMenuPageFileName($pLocalCfgArray)
{
  return ($pLocalCfgArray["GUIDE_MARKER"] . ".html");
}


/**
 *  (III.D) generate an adequate image-tag-string
 */
function formImgTag
( $pImageName,
  $pImageFileName,
  $pLocalCfgArray,
  &$pImageSizeStr,
  $pAlt="",
  $pIndent=""
)
{
  
  if (!($pImageFileName))
    return "";
    
  $buildImagePath=sprintf("%s/%s/%s",$pLocalCfgArray["SITE_ID"] ,$pLocalCfgArray["IMG_DIR"],$pImageFileName);
   
  if (file_exists($buildImagePath))
  {
    $imageSizeArray=getimagesize($buildImagePath);
    $pImageSizeStr=$imageSizeArray[3];
  } 
  
  $nameAttribute="";
  if ($pImageName)
    $nameAttribute=sprintf("name=\"%s\"",$pImageName);
  
  $altAttribute="";
  if ($pAlt)
    $altAttribute=sprintf("alt=\"%s\"",htmlentities($pAlt));
  
  
   return
    ( sprintf
      ( "%s<img %s src=\"../%s/%s\" %s %s border=\"0\">",
        $pIndent,
        $nameAttribute,
        $pLocalCfgArray["IMG_DIR"],
        $pImageFileName,
        $pImageSizeStr,
        $altAttribute
      )
     );
}

/**
 *  (III.E) generate the corresponding body tag
 */
function formBodyTag($pLocalCfgArray,$pTargetType="")
{
  
  $bgPicAttribute="";
  
  switch($pTargetType)
  {
    case "logo":
      $bgPictureKey="LOGO_BACKGROUND_PICTURE";
      $bgColorKey="LOGO_BACKGROUND_COLOR";
      break;
    case "mainmenu":
      $bgPictureKey="MMAR_BACKGROUND_PICTURE";
      $bgColorKey="MMAR_BACKGROUND_COLOR";
      break;
    case "submenu":
      $bgPictureKey="SMAR_BACKGROUND_PICTURE";
      $bgColorKey="SMAR_BACKGROUND_COLOR";
      break;
    case "page":
      $bgPictureKey="PAGE_BACKGROUND_PICTURE";
      $bgColorKey="PAGE_BACKGROUND_COLOR";
      break;
    default:
      $bgPictureKey="BACKGROUND_PICTURE";
      $bgColorKey="BACKGROUND_COLOR";
      break;
  }
  
  if (!($pLocalCfgArray[$bgPictureKey]))
    $bgPictureKey="BACKGROUND_PICTURE";
    
  if (!($pLocalCfgArray[$bgColorKey]))
  {
    $bgColorKey="BACKGROUND_COLOR";
  }  
  
  if ($pLocalCfgArray[$bgPictureKey])
    $bgPicAttribute=sprintf
    ( "background=\"../%s/%s\"",
      $pLocalCfgArray["IMG_DIR"],
      $pLocalCfgArray[$bgPictureKey]
    );
    
  return
  (
    sprintf
    ( ( "<body bgColor=\"%s\" ".
      	"$bgPicAttribute ".
      	"text=\"%s\" ".
      	"link=\"%s\" ".
      	"vlink=\"%s\" ".
      	"alink=\"%s\" ".
      	">\n"
      ),
      $pLocalCfgArray[$bgColorKey],
      $pLocalCfgArray["TEXT_COLOR"],
      $pLocalCfgArray["LINK_COLOR"],
      $pLocalCfgArray["VLINK_COLOR"],
      $pLocalCfgArray["ALINK_COLOR"]
    )
  );
}

/**
 *  (III.F) write the content into a file being positioned into dir
 */
function writePage($pFileDir,$pFileName,$pFileContent)
{
  if ($pFileDir != "")
  {
    $filePath=($pFileDir . "/" . $pFileName);
  }
  else
    $filePath=($pFileName);

  if (!($fp=fopen($filePath,"w")))
    return false;
    
  if (fwrite($fp,$pFileContent)<0)
    return false;
  fclose($fp);
  return true;
}


/*** (IV) funktions for log-handling ***/

/**
 * (IV) logging functions
 */


/**
 * (IV.a) write the html-page-header for logging
 */
function startHtmlLogging()
{
  $date=date("Y-m-d-\T-H-i-s");
  print
  ( "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n" .
    "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" " .
      	"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n" .
    "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n" .
    "<head>\n" . 
    "  <meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />\n" .
    "  <meta name=\"author\" content=\"lgsp.php\" />\n" .
    "  <meta name=\"date\" content=\"$date\" />\n" .
    "  <title>lgsp-logging: $date</title>\n" .
    "</head>\n" .
    "<body bgcolor=\"#aaaaaa\" text=\"#000000\">\n" .
    "<span style=\"font-size:12pt\">\n"
  );

  insertLgspReturnButton();
}

/**
 * (IV.b) write an html-action-message
 */
function sendHtmlActionMessage($pLogMessage,$pLogAdd1="", $pLogAdd2="")
{
  print(htmlentities($pLogMessage) . "<br />\n");
  if ($pLogAdd1)
    print("  " . htmlentities($pLogAdd1) . "<br />\n");
  if ($pLogAdd2)
    print("  " . htmlentities($pLogAdd2) . "<br />\n");
  
}

/**
 * (IV.c) write an html-error-message
 */
function sendHtmlErrorMessage($pErrorMessage,$pLogAdd1="", $pLogAdd2="")
{
  print("<span style=\"color:#ff0000\">\n  error:</span> ");
  print(htmlentities($pErrorMessage) . "<br />\n");
  if ($pLogAdd1)
    print("         " . htmlentities($pLogAdd1) . "<br />\n");
  if ($pLogAdd2)
    print("         " . htmlentities($pLogAdd2) . "<br />\n");
  
}

/**
 * (IV.d) write an html-success-message
 */
function sendHtmlSuccessMessage($pSuccessMessage,$pLogAdd1="", $pLogAdd2="")
{
  print("<span style=\"color:#00FF00\">\n  success:</span> ");
  print(htmlentities($pSuccessMessage) . "<br />\n");
  if ($pLogAdd1)
    print("         " . htmlentities($pLogAdd1) . "<br />\n");
  if ($pLogAdd2)
    print("         " . htmlentities($pLogAdd2) . "<br />\n");
  
}
/**
 * (IV.e) write the lgsp-return-button
 */
function insertLgspReturnButton()
{
  global $gLgspReturnTarget;
  global $gLgspConfigurationFile;
  
  $tgp=urlencode($gLgspConfigurationFile);
  if ($gLgspReturnTarget)
  {
    print("<p><a href=\"$gLgspReturnTarget?LGSP_CONFIGURATION_FILE=$tgp\">$gLgspReturnTarget</a></p>\n");
  }
}

/**
 * (IV.f) write the html-page-footer for logging
 */
function finishHtmlLogging()
{
  insertLgspReturnButton();
  print
  ( 
    "</span>\n" .
    "</body>\n" .
    "</html>\n"
  );
  
}


?>
