<?

// Copyright (C) 2003 Karsten Reincke <karsten.reincke@karubik.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// file <lgsp.cfg.inc> version <#1.0.0#> of project <lgsp>

return array
(

  /* (1) some general defaults */

  "SITE_ID" => "lgsp",	      	    /* top-directory of the site */
  "IMG_DIR" => "img", 	      	    /* image directory for buttons */
  "CSS_DIR" => "css", 	      	    /* directory for style-sheet-files */
  "INTRO_MARKER" => "index",  	    /* the main file of a (mme) directory */
  "LOGO_MARKER" => "logo", 	    /* the file which contains the (mme) logo */
  "MENU_MARKER" => "menu", 	    /* the file which contains the main-menu */
  "GUIDE_MARKER" => "submenu",	    /* the file which contains the sub-menu */

  "WRITE_XML_DECLARATION" => "yes", /* print the xml declaration line as first line */
 
  /* some default infos for writing a page */
  "AUTHOR" => "Karsten Reincke",   /* the main author of the site */
  "ENCODING" => "iso-8859-1",       /* encoding of the site pages (iso-8859-1|utf-8) */

  "TITLE" => "edit mainmenu",    /* mme (window) title (no special signs!) */
  "ABSTRACT" => "The Little GNU Site Preparer", /* short mme specification */ 	
  "DESCRIPTION" => "Tool for generating the frame pages of a site ", /* long mme specification */  	
      
  "KEYWORDS_EN" => "Site, Page, Editor",  /* english keywords for specifying this subsite */
  "KEYWORDS_FREE" => "Site, Html, Seite", /* keywords in foreign language for specifying the site */
  "KEYWORDS_FREE_LANGUAGE" => "de",       /* type of the used foreign language */
  
  "BACKGROUND_PICTURE" => "", 	    /* the default background picture */
  "BACKGROUND_COLOR" => "#cccccc",  /* the default background color */

  "TEXT_COLOR" => "#440000",	    /* the default text color */
  "LINK_COLOR" => "#0000ff",	    /* the default color for still unvisited links */
  "VLINK_COLOR" => "#000088",	    /* the default color for already visited links */
  "ALINK_COLOR" => "#880000",	    /* the default color for just active links */
  "HOVER_COLOR" => "#ff0000",       /* the default color for mouse-over-links */


  /* some default infos for writing the index page */
  
  "MENU_AREA_HEIGHT" => "100", 	    /* the height of of the main-menu-area */
  "GUIDE_AREA_WIDTH" => "130", 	    /* the width of of the sub-menu-area */

  /* some infos for writing the logo page */
  "LOGO_TOP_MARGIN" => "4",  	    /* distance between window-border and top logo-border */
  "LOGO" => "lgsp.png",       	    /* logofile (must be copied into SITE_ID/IMG_DIR) */

  /* some infos for writing the guide page */
  "MME_MARKER" => "lgsp-marker.png", /* button which appears before each mme-entry in the guide-area */
  "WITH_IMPRESSUM" => "yes",  	     /* insert a permanently visible link to an impressum-file */
  
  /* some infos for writing the mainmenu page */
  "MAIN_MENU_TOP_MARGIN" =>"20",       /* distance between window-border and top menu-border */
  "MME_BGSTRIPE_COLOR" => "",  /* specific background-colors for the main-menu-entry */
  "MME_BGSTRIPE_SIZE" => "0",         /* size of the background-strip containing BGSTRIPE_COLOR */
  "HEADLINE" => "Little GNU Site Preparer", /* text or url which appears above of the mme-entries */
  "SUBLINE" => "", /* text or url which appears above of the mme-entries */
  
  "MAIN_MENU" => array	      	    /* all main-menu entries which constitute a sub-site */
  (
    0 => array
    (
      "MME_ID" => "doc",       /* main-menu-entry-id (also used as directory name) */
           
      "MME_TEXT" => "LGSP", /* main-menu-entry (appears as text or as alt-tag of a button) */
      
      /* button for selecting the main-menu-entry */
      "ENABLED_BUTTON" => "lgsp-select.png", 	
      /* button which appears if the mouse is over normal button */      
      "MOUSEOVER_BUTTON" => "lgsp-touched.png", 
      /* button which appears if the normal button has been touched */      
      "MOUSEDOWN_BUTTON" => "lgsp-pressed.png",
      /* button which appears if the mme has already been selected */       
      "DISABLED_BUTTON" => "lgsp-selected.png",        
            
      "TITLE" => "lgsp documentation",    /* mme (window) title (no special signs!) */
      "ABSTRACT" =>   	      	      /* short mme specification */
      "The Little GNU Site Preparer: subsite for documenting the use of lgsp",  	
      "DESCRIPTION" =>        	      /* long mme specification */
      (  "Subsite for documenting the use of the Little GNU Site Preparer"
      ),  	
            
      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
        
      	0 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-idea",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-idea.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "Idea",
          /* window-title of target-file itself */ 
	  "TITLE" => "The idea of LGSP",    
          /* short description of target-file itself */
	  "ABSTRACT" => "Explanation of the Idea of LGSP", 
	),
      	1 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-howto",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-howto.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "Howto",
          /* window-title of target-file itself */ 
	  "TITLE" => "The LGSP howto",    
          /* short description of target-file itself */
	  "ABSTRACT" => "Howto work with LGSP", 
	),
      	2 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-faq",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-faq.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "FAQ",
          /* window-title of target-file itself */ 
	  "TITLE" => "The LGSP faq",    
          /* short description of target-file itself */
	  "ABSTRACT" => "The LGSP faq", 
	),
      	3 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-download",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-download.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "Download",
          /* window-title of target-file itself */ 
	  "TITLE" => "The LGSP download",    
          /* short description of target-file itself */
	  "ABSTRACT" => "The LGSP download", 
	),
      	4 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-licence",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-licence.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "Licence",
          /* window-title of target-file itself */ 
	  "TITLE" => "The LGSP licence",    
          /* short description of target-file itself */
	  "ABSTRACT" => "The LGSP licence", 
	),
      	4 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "lgsp-author",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "lgsp-author.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "Author",
          /* window-title of target-file itself */ 
	  "TITLE" => "The LGSP author",    
          /* short description of target-file itself */
	  "ABSTRACT" => "The LGSP author", 
	),
      )
    ),
    1 => array
    (
      "MME_ID" => "stc",       /* main-menu-entry-id (also used as directory name) */
           
      "MME_TEXT" => "site configuration", /* main-menu-entry (appears as text or as alt-tag of a button) */
      
      /* button for selecting the main-menu-entry */
      "ENABLED_BUTTON" => "lgsp-stc-select.png", 	
      /* button which appears if the mouse is over normal button */      
      "MOUSEOVER_BUTTON" => "lgsp-stc-touched.png", 
      /* button which appears if the normal button has been touched */      
      "MOUSEDOWN_BUTTON" => "lgsp-stc-pressed.png",
      /* button which appears if the ste has already been selected */       
      "DISABLED_BUTTON" => "lgsp-stc-selected.png",        
           
      "TITLE" => "site configuration",    /* mme (window) title (no special signs!) */
      "ABSTRACT" =>   	      	      /* short mme specification */
      "The Little GNU Site Preparer: subsite for editing the global site parameters",  	
      "DESCRIPTION" =>        	      /* long mme specification */
      ( "editing the global site parameters means determining " .
        "the default values which may be overwritten by more specific " .
	"paramaters"
      ),  	
            
      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
      	0 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "show-site-cfg",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "show-site-cfg.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "show all parameters",
          /* window-title of target-file itself */ 
	  "TITLE" => "show whole site configruation file",    
          /* short description of target-file itself */
	  "ABSTRACT" => "prints the actual state of the whole site configuration file", 
	),
        
      	1 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "generate-site-cfg",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "generate-site-cfg.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "generate file",
          /* window-title of target-file itself */ 
	  "TITLE" => "generate initial configuration file",    
          /* short description of target-file itself */
	  "ABSTRACT" => "generate configuration template file", 
	),
      	2 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "select-site-cfg",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "select-site-cfg.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "select file",
          /* window-title of target-file itself */ 
	  "TITLE" => "select site configruation file",    
          /* short description of target-file itself */
	  "ABSTRACT" => "allows to select a new site configuration file", 
	),
      	3 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "change-site-cfg",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "change-site-cfg.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "change global parameters",
          /* window-title of target-file itself */
	  "TITLE" => "change the global (default) site parameters",
          /* short description of target-file itself */    
	  "ABSTRACT" => "allows the changings of the global (default) site parameters",  
	),
      )
    ),
    2 => array
    (
      "MME_ID" => "mmc",       /* main-menu-entry-id (also used as directory name) */
           
      "MME_TEXT" => "mainmenu configuration", 	  /* main-menu-entry (appears as text or as alt-tag of a button) */
      
      /* button for selecting the main-menu-entry */
      "ENABLED_BUTTON" => "lgsp-mmc-select.png", 	
      /* button which appears if the mouse is over normal button */      
      "MOUSEOVER_BUTTON" => "lgsp-mmc-touched.png", 
      /* button which appears if the normal button has been touched */      
      "MOUSEDOWN_BUTTON" => "lgsp-mmc-pressed.png",
      /* button which appears if the mme has already been selected */       
      "DISABLED_BUTTON" => "lgsp-mmc-selected.png",        
            
      "TITLE" => "mainmenu configuration",    /* mme (window) title (no special signs!) */
      "ABSTRACT" =>   	      	      /* short mme specification */
      "The Little GNU Site Preparer: subsite for editing the mainmenu",  	
      "DESCRIPTION" =>        	      /* long mme specification */
      ( "editing the mainmenu means adding a new entry, " .
        "deleting an existing entry or " .
	"changing the content of an existing entry"
      ),  	
            
      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
      	0 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "change-mme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "change-mme.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "change entry",
          /* window-title of target-file itself */
	  "TITLE" => "change an existing mainmenu entry",
          /* short description of target-file itself */    
	  "ABSTRACT" => "changes the configuration values of an existing mainmenu entry",  
	),	
      	1 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "generate-mme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "generate-mme.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "add entry",
          /* window-title of target-file itself */ 
	  "TITLE" => "generate new mainmenu entry",    
          /* short description of target-file itself */
	  "ABSTRACT" => "generates a new mainmenu entry using default values", 
	),
      	2 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "delete-mme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "delete-mme.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "delete entry",
          /* window-title of target-file itself */
	  "TITLE" => "delete existing mainmenu entry",
          /* short description of target-file itself */    
	  "ABSTRACT" => "erases an existing mainmenu entry and all corresponding submenus",  
	),
      	3 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "resort-mainmenu",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "resort-mainmenu.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "resort mainmenu",
          /* window-title of target-file itself */
	  "TITLE" => "resort mainmenu",
          /* short description of target-file itself */    
	  "ABSTRACT" => "rearranges the order of the corresponding mainmenu entries",  
	),
      )
    ),
    3 => array
    (
      "MME_ID" => "smc",       /* main-menu-entry-id (also used as directory name) */
           
      "MME_TEXT" => "submenu configuration", 	  /* main-menu-entry (appears as text or as alt-tag of a button) */
      
      /* button for selecting the main-menu-entry */
      "ENABLED_BUTTON" => "lgsp-smc-select.png", 	
      /* button which appears if the mouse is over normal button */      
      "MOUSEOVER_BUTTON" => "lgsp-smc-touched.png", 
      /* button which appears if the normal button has been touched */      
      "MOUSEDOWN_BUTTON" => "lgsp-smc-pressed.png",
      /* button which appears if the mme has already been selected */       
      "DISABLED_BUTTON" => "lgsp-smc-selected.png",        
            
      "TITLE" => "submenu configuration",    /* mme (window) title (no special signs!) */
      "ABSTRACT" =>   	      	      /* short mme specification */
      "The Little GNU Site Preparer: subsite for editing a submenu",  	
      "DESCRIPTION" =>        	      /* long mme specification */
      ( "editing the submenu means adding a new entry, " .
        "deleting an existing entry or " .
	"changing the content of an existing entry"
      ),  	
            
      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
     	0 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "change-sme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "change-sme.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "change entry",
          /* window-title of target-file itself */
	  "TITLE" => "change an existing submenu entry configuration",
          /* short description of target-file itself */    
	  "ABSTRACT" => "changes the configuration values of an existing submenu entry",  
	),	
      	1 => array
	(
	  /* sub-menu-entry-id */
          "SME_ID" => "generate-sme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "generate-sme.php",
          /* text which hints to the target-file */  	  
	  "SME_TEXT" => "add entry",
          /* window-title of target-file itself */ 
	  "TITLE" => "generate new submenu entry",    
          /* short description of target-file itself */
	  "ABSTRACT" => "generates a new submenu entry using default configuration values", 
	),
      	2 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "delete-sme",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "delete-sme.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "delete entry",
          /* window-title of target-file itself */
	  "TITLE" => "delete existing submenu entry",
          /* short description of target-file itself */    
	  "ABSTRACT" => "erases the configruation values for an existing submenu entry",  
	),
      	3 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "resort-submenu",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "resort-mme-submenu.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "resort submenu",
          /* window-title of target-file itself */
	  "TITLE" => "resort submenu",
          /* short description of target-file itself */    
	  "ABSTRACT" => "rearranges the order of the corresponding submenu entries",  
	),
      )
    ),
    4 => array
    (
      "MME_ID" => "sce",       /* main-menu-entry-id (also used as directory name) */
           
      "MME_TEXT" => "site generation", 	  /* main-menu-entry (appears as text or as alt-tag of a button) */
      
      /* button for selecting the main-menu-entry */
      "ENABLED_BUTTON" => "lgsp-sce-select.png", 	
      /* button which appears if the mouse is over normal button */      
      "MOUSEOVER_BUTTON" => "lgsp-sce-touched.png", 
      /* button which appears if the normal button has been touched */      
      "MOUSEDOWN_BUTTON" => "lgsp-sce-pressed.png",
      /* button which appears if the mme has already been selected */       
      "DISABLED_BUTTON" => "lgsp-sce-selected.png",        
            
      "TITLE" => "generate a new site",    /* mme (window) title (no special signs!) */
      "ABSTRACT" =>   	      	      /* short mme specification */
      "The Little GNU Site Preparer: subsite for generating a site by evaluating a configuration file",  	
      "DESCRIPTION" =>        	      /* long mme specification */
      ( "generating a site means " .
        "evaluating a LGSP configuration file " .
	"and generating the described pages and directories"
      ),  	
            
      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
     	0 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "visit-site",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "visit-site.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "visit generated site",
          /* window-title of target-file itself */
	  "TITLE" => "regard already generated the site",
          /* short description of target-file itself */    
	  "ABSTRACT" => "regard already generated the site",  
	),	
     	1 => array
	(
          /* sub-menu-entry-id */
	  "SME_ID" => "generate-site",
          /* target-file of sub-menu-entry */	      	  
	  "LINK_TARGET" => "generate-site.php",
           /* text which hints to the target-file */  	  
	  "SME_TEXT" => "generate new site",
          /* window-title of target-file itself */
	  "TITLE" => "evaluate configuration file and generate the site",
          /* short description of target-file itself */    
	  "ABSTRACT" => "evaluate configuration file and generate the site",  
	),	
      ),
    ),

  )
);
?>
