<?

// Copyright (C) 2003 Karsten Reincke <karsten.reincke@karubik.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// file <default.cfg.inc> version <#1.0.0#> of project <lgsp>

return array
(

  /* (1) some general defaults */

  "SITE_ID" => "site",	      	    /* top-directory of the site */
  "IMG_DIR" => "img", 	      	    /* image directory for buttons */
  "CSS_DIR" => "css", 	      	    /* directory for style-sheet-files */
  "INTRO_MARKER" => "index",  	    /* the main file of a (mme) directory */
  "LOGO_MARKER" => "logo", 	    /* the file which contains the (mme) logo */
  "MENU_MARKER" => "menu", 	    /* the file which contains the main-menu */
  "GUIDE_MARKER" => "guide",	    /* the file which contains the sub-menu */
  
  "WRITE_XML_DECLARATION" => "yes", /* print the xml declaration line as first line */
  
  /* some default infos for writing a page */
  "AUTHOR" => "Vorname Nachname",   /* the main author of the site */
  "ENCODING" => "iso-8859-1",       /* encoding of the site pages (iso-8859-1|utf-8) */

  "TITLE" => "site-title",	    /* (window) title (no special signs!) */
  "ABSTRACT" => "site-abstract",    /* short mme specification */
  "DESCRIPTION" => "site-desc.",    /* long mme specification */
  "AUTHOR" => "site-author",        /* author of all pages which constitute this subsite */
  "KEYWORDS_EN" => "site-enkw",     /* english keywords for specifying this subsite */
  "KEYWORDS_FREE" => "site-dekw",   /* keywords in foreign language for specifying this subsite */
  "KEYWORDS_FREE_LANGUAGE" => "de", /* type of the used foreign language */

  "BACKGROUND_PICTURE" => "", 	    /* the default background picture */
  "BACKGROUND_COLOR" => "#bbbbbb",  /* the default background color */

  "TEXT_COLOR" => "#440000",	    /* the default text color */
  "LINK_COLOR" => "#ff0000",	    /* the default color for still unvisited links */
  "VLINK_COLOR" => "#880000",	    /* the default color for already visited links */
  "ALINK_COLOR" => "#008800",	    /* the default color for just active links */
  "HOVER_COLOR" => "#000088",       /* the default color for mouse-over-links */

  /* some default infos for writing the index page */
  
  "MENU_AREA_HEIGHT" => "60", 	    /* the height of of the main-menu-area */
  "GUIDE_AREA_WIDTH" => "80", 	    /* the width of of the sub-menu-area */

  /* some infos for writing the logo page */
  "LOGO_TOP_MARGIN" => "10",  	    /* distance between window-border and top logo-border */
  "LOGO" => "",       	      	    /* logofile (must be copied into SITE_ID/IMG_DIR) */

  /* some defaults for writing the guide page */
  "MME_MARKER" => "",        /* button which appears before each mme-entry in the guide-area */

  /* some infos for writing the main menu page */
  "MAIN_MENU_TOP_MARGIN" =>"0",     /* distance between window-border and top menu-border */
  "MME_BGSTRIPE_COLOR" => "#0000ff",  /* specific background-colors for the main-menu-entry */
  "MME_BGSTRIPE_SIZE" => "4",         /* size of the background-strip containing BGSTRIPE_COLOR */
  
  "MAIN_MENU" => array	      	    /* all main-menu entries which constitute a sub-site */
  (
    0 => array
    (
      "MME_ID" => "mme1",     	      /* main-menu-entry-id (also used as directory name) */

      "LOGO_TOP_MARGIN" => "",	      /* distance between window-border and mme-logo-border */
      "LOGO" => "",   	      	      /* specific mme-logo (searched in SITE_ID/IMG_DIR) */

      "MAIN_MENU_TOP_MARGIN" => "10", /* distance between window-border and top menu-border */
      
      "HEADLINE" => "",       	      /* text or url which appears above of the mme-entries */
      "HEADPICTURE" => "",  	      /* image which appears above of the mme-entries */
      
      "MME_TEXT" => "mme1-entry",     /* main-menu-entry (appears as text or as alt-tag of a button) */
      "MME_BGSTRIPE_COLOR" => "",     /* specific background-colors for the main-menu-entry */
      "MME_BGSTRIPE_SIZE" => "0",     /* size of the background-strip containing BGSTRIPE_COLOR */
      "ENABLED_BUTTON" => "", 	      /* button for selecting the main-menu-entry */
      "MOUSEOVER_BUTTON" => "",       /* button which appears if the mouse is over normal button */
      "MOUSEDOWN_BUTTON" => "",       /* button which appears if the normal button has been touched */
      "DISABLED_BUTTON" => "",        /* button which appears if the mme has already been selected */

      "MME_MARKER" => "",        /* button which appears before each mme-entry in the guide-area */
       
      "SUBLINE" => "",	      	      /* text or url which appears below of the mme-entries */
      "SUBPICTURE" => "",     	      /* image which appears below of the mme-entries */
      
      "TITLE" => "mme1-title",	      	/* mme (window) title (no special signs!) */
      "ABSTRACT" => "mme1-abstract",  	/* short mme specification */
      "DESCRIPTION" => "mme1-desc.",  	/* long mme specification */
      "AUTHOR" => "mme1-author",      	/* author of all pages which constitute this subsite */
      "KEYWORDS_EN" => "mme1-enkw",   	/* english keywords for specifying this subsite */
      "KEYWORDS_FREE" => "mme1-dekw", 	/* keywords in foreign language for specifying this subsite */
      "KEYWORDS_FREE_LANGUAGE" => "de", /* type of the used foreign language */
      
      "MENU_AREA_HEIGHT" => "60",     	 /* height of of the main-menu-area in this subsite */
      "GUIDE_AREA_WIDTH" => "80",     	 /* width of of the sub-menu-area in this subsite */
      
      "BACKGROUND_PICTURE" => "",   /* the specific background picture in this subsite */
      "BACKGROUND_COLOR" => "",     /* the specific background color in this subsite */

      "TEXT_COLOR" => "",     /* the specific text color in this subsite */
      "LINK_COLOR" => "",     /* the specific color for still unvisited links in this subsite */
      "VLINK_COLOR" => "",    /* the specific color for already visited links in this subsite */
      "ALINK_COLOR" => "",    /* the specific color for just active links in this subsite */
      "HLINK_COLOR" => "",    /* the specific color for mouse-over-links in this subsite */

      "SUB_MENU" => array     /* all sub-menu entries which are linked to real content pages */
      (
      	0 => array
	(
	  "SME_ID" => "sme11",	      	      	  /* sub-menu-entry-id */
	  "LINK_TARGET" => "sme11.html",  	  /* target-file of sub-menu-entry */
	  "SME_TEXT" => "sme11",     	      	  /* text which hints to the target-file */
	  "TITLE" => "sme11-title",   	      	  /* window-title of target-file itself */
	  "ABSTRACT" => "sme11-abstract",     	  /* short description of target-file itself */
	  "AUTHOR" => "sme11-author",  	      	  /* specific author of target-file itself */
      	  "KEYWORDS_EN" => "sme11-en-keywords",	  /*  english keywords specifying the target-file */
      	  "KEYWORDS_FREE" => "sme11-de-keywords", /*  foreign keywords specifying the target-file */
      	  "KEYWORDS_FREE_LANGUAGE" => "de",    	      	  /*  type of foreign keyword language */

      	  "BACKGROUND_PICTURE" => "", 	/* the specific background picture of the target-file */
     	  "BACKGROUND_COLOR" => "",   	/* the specific background color of the target-file */

      	  "TEXT_COLOR" => "", 	/* the specific text color of the target-file */
      	  "LINK_COLOR" => "", 	/* the specific color for still unvisited links of the target-file */
      	  "VLINK_COLOR" => "",	/* the specific color for already visited links of the target-file */
      	  "ALINK_COLOR" => "",	/* the specific color for just active links of the target-file */
      	  "HLINK_COLOR" => "",	/* the specific color for mouse-over-links of the target-file */
	),
	

      	2 => array(), 	/* empty main-menu-entries evoke a limit-line */
	
      )
    ),
  )
);
?>
